{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gGrip;
{$D 'Ivan Lee Herring, 2006:  GRIP ICE Version 1.7'}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Registry,
  pngimage, jpeg, Clipbrd, Printers, StdCtrls,
  Menus, ExtCtrls, Gauges, Buttons, ExtDlgs,
  ComCtrls, ToolWin, ImgList;


type
  TGRIPForm = class(TForm)
    OpenDialog: TOpenDialog;
    ScrollBox1: TScrollBox;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;

    MainMenu1: TmainMenu;
    File1: TMenuItem;
    F_Open: TMenuItem;
    F_Save: TMenuItem;
    F__Saveas: TMenuItem;
    FS__Saveas: TMenuItem;
    FS_BMP: TMenuItem;
    FS_JPG: TMenuItem;
    F_ImageManager: TMenuItem;
    F_Print: TMenuItem;
    F_Exit: TMenuItem;
    EO__Options: TMenuItem;


    Investigate1: TMenuItem;
    I_Undo: TMenuItem;
    IZ_ZoomWindow: TMenuItem;
    IV__ViewtoaDisplay: TMenuItem;
    IV_PixelValues: TMenuItem;
    IV_CMYScreen: TMenuItem;
    IV_RGBScreen: TMenuItem;
    IV_onlyBlue: TMenuItem;
    IV_onlyGreen: TMenuItem;
    IV_onlyRed: TMenuItem;
    IH__Histogram: TMenuItem;
    IL__Linear: TMenuItem;
    IP__PixelAlgebra: TMenuItem;
    IS__SpatialMatrix: TMenuItem;
    IU__Classification: TMenuItem;
    I_SystemInfo: TMenuItem;

    Extrapolate1: TMenuItem;
    X_LabelObjects: TMenuItem;
    X_ObjectorMM: TMenuItem;
    N21: TMenuItem;
    N5: TMenuItem;
    N13: TMenuItem;
    N1: TMenuItem;
    Classify1: TMenuItem;
    Image1: TImage;
    PngInfo1: TMenuItem;
    LoadFileDialog: TOpenPictureDialog;
    N6: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N7: TMenuItem;
    X_Macro: TMenuItem;
    LogtoDIP: TMenuItem;
    SaveNumbered1: TMenuItem;
    N2: TMenuItem;
    PreprocessPngs1: TMenuItem;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    SaveButton: TToolButton;
    PrintButton: TToolButton;
    FlyByButton: TToolButton;
    ViewPixelsBtn: TToolButton;
    Gauge1: TGauge;
    UndoBtn: TToolButton;
    HistogramBtn: TToolButton;
    LinearBtn: TToolButton;
    PixelAlgebraButton: TToolButton;
    FilterEditorBtn: TToolButton;
    ClassificationBtn: TToolButton;
    MacroBtn: TToolButton;
    LabelBtn: TToolButton;
    LabelObjectsBtn: TToolButton;
    AboutBtn: TToolButton;
    HelpBtn: TToolButton;
    ExitBtn: TToolButton;
    Timer1: TTimer;
    IF__FFT: TMenuItem;
procedure DisplaySplashScreen;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Do_MenuDefaults;

    procedure ShowHint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure F_OpenClick(Sender: TObject);
    procedure LoadFromFile(Filename: string);
{    procedure ImageProgress(Sender: TObject; Stage: TProgressStage;
      PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
      const Msg: string);}
    procedure Progress(Value: Byte);
    procedure F_PrintClick(Sender: TObject);
    procedure F_ExitClick(Sender: TObject);
    procedure F_SaveClick(Sender: TObject);
    procedure F__SaveasClick(Sender: TObject);
    procedure SaveImage;
    procedure IZ_ZoomWindowClick(Sender: TObject);
    procedure FS_BMPClick(Sender: TObject);
    procedure FS_JPGClick(Sender: TObject);

    procedure MultiImage1MouseDown(Sender: TObject; Button:
      TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MultiImage1MouseMove(Sender: TObject; Shift:
      TShiftState; X,
      Y: Integer);
    procedure MultiImage1MouseUp(Sender: TObject; Button:
      TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawRubberband;
    procedure DrawRubberMark;


    procedure I_UndoClick(Sender: TObject);
    procedure IV_PixelValuesClick(Sender: TObject);
    procedure IV_PixelValuesUnClick;
    procedure IV_CMYScreenClick(Sender: TObject);
    procedure IV_RGBScreenClick(Sender: TObject);
    procedure IV_onlyRedClick(Sender: TObject);
    procedure IV_onlyGreenClick(Sender: TObject);
    procedure IV_onlyBlueClick(Sender: TObject);
    procedure I_SystemInfoClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure X_LabelObjectsClick(Sender: TObject);
    procedure EO__OptionsClick(Sender: TObject);
    procedure IH__HistogramClick(Sender: TObject);
    procedure IU__ClassificationClick(Sender: TObject);
    procedure IL__LinearClick(Sender: TObject);
    procedure IP__PixelAlgebraClick(Sender: TObject);
    procedure IS__SpatialMatrixClick(Sender: TObject);
    procedure F_ImageManagerClick(Sender: TObject);
    procedure PngInfo1Click(Sender: TObject);
    procedure X_ObjectorMMClick(Sender: TObject);
    procedure X_MacroClick(Sender: TObject);
    procedure LogtoDIPClick(Sender: TObject);
    procedure SaveNumbered1Click(Sender: TObject);
    procedure PreprocessPngs1Click(Sender: TObject);
    procedure AboutBoxBtnClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
procedure FreeForm;
    procedure IF__FFTClick(Sender: TObject);
  private
    { Private declarations var}
  Loading: Boolean;{ = FALSE;}
  LastPos: Integer;
  procedure WMEndSession(var Msg:TWMEndSession); message WM_ENDSESSION;
  public
    { Public declarations }

  end;


var
  GRIPForm: TGRIPForm;



implementation

uses
  {GRIPForm  0, 25 Status bar}
   AllSplash,{SplashScreen}
     {gUScreenPrint  FormPrint}
  gGlobal, guEnabler, gPrOptions,{OptionsForm   3000....x}
  gSysInfo,{SystemInfoForm  13000}
  gInfo,  {FrInfo 12000}
  gVCScreen,{ViewCursorScreen 5500x}
  gMagniForm, {MagniForm  5000}
  gAbout,{AboutGrip   222}
  gPBands,{PBands  2000}
    gPBHdr, {gPBHdr PBandHdrForm  2003}
    {buzMemoFrm buzMemoForm       buzHelpContextl 123}
    gDisProFrm, {DisProcessForm 2720  2270 ..2420 2210  2130}
       {gPBandsHisFrm  ExtraImageViewForm  2271}
  guHistoCC, gHistogram,{HistogramForm   6000}
    gPSize, {gPSize PrintersizeForm 6051x}
  guILinear, gLinear, {LinearForm 7000}
    {gDistance DistanceForm  7900x}
    gLProfile,{ LineProfileForm  7500x}{Uses TRGBTripleArray}
  gFEditor, {FEditForm  9000}
  gFFTFrm, {FFTForm   10000}
  gClassifier,{ClassificationForm   11000}
  gPixelAlgebra,{PixelAlgebraForm   8000}
  gXAnnoLO, {LabelObjectsForm  14000}
  gOMark,{ObjectMarkForm   435}
  gREIV,{REIVForm    234x}
    {gRotate  RotateForm    5555x}
    {gResize ResizeForm 250x}
  gMacro{MacroForm    17500}
  ;

{$R *.DFM}

{---------------------------------------------------------------------}

function myTestImage: Boolean; {ONLY handle 24 bit colors}
var
  temp: Integer;
  dc: HDC;
begin
  dc := GetDc(0);
  if ((GetDeviceCaps(dc, BITSPIXEL) = 24)
    or (GetDeviceCaps(dc, BITSPIXEL) = 32)) then
  begin
    if (GetDeviceCaps(dc, BITSPIXEL) = 24) then
    begin
      MyPixelFormat := pf24bit;
      PixelScanSize := 3;
    end else
    begin
      If DisplayConvert32 then DoMessages(40);
      MyPixelFormat := pf24bit;
      PixelScanSize := 3;
    {    MyPixelFormat:=pf32bit;
    PixelScanSize:=4;}
    end;
    temp := ReleaseDc(0, dc); {Give back the screen dc}
    if temp <> 1 then Application.Terminate;
    myTestImage := True;
  end else
  begin {or 36}
    DoMessages(11);
    temp := ReleaseDc(0, dc);
    if temp <> 1 then Application.Terminate;
    //Commnet out to allow processing.. no telling what happens
    myTestImage := False;
  end; {of if 24 bit}
end; {of this}

procedure TGRIPForm.WMEndSession(var Msg:TWMEndSession);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\RunOnce', True)
    then Reg.WriteString('Grip','"' + ParamStr(0) + '"');
  finally
    Reg.CloseKey;
    Reg.Free;
    inherited;
  end;
end;
procedure TGRIPForm.DisplaySplashScreen;
begin
  SplashScreen := TSplashScreen.Create(Application);
  SplashScreen.SplashSet(10,2000);
  SplashScreen.Show;
  SplashScreen.Refresh;
  {Self destroy}
end;

procedure TGRIPForm.FormCreate(Sender: TObject);
var
  Helps: string;
  i:Integer;
begin
If myTestImage then DisplaySplashScreen else Application.Terminate;
 {LOAD Raster.RPM and SET these}
  if FileExists(ExtractFilePath(ParamStr(0)) + 'Grip.pof') then
  begin
    DoLoader;
  end else begin
    StartedNameNumber := 'Not Registered'; {ILH97432-460875}
    Started := Date;
    MapBaseColor := 123;
    Helps:='';
    HiddenString:=
      'GRIP ICE 1.5 Copyright, 2004: Ivan Lee Herring';
    For i:=length(HiddenString) to 254 do
    Helps:= Helps + char(random(128)+32);
    HiddenString:=
      'GRIP ICE 1.5 Copyright, 2004: Ivan Lee Herring'
      +Helps;    
    RasterFormX := 10;
    RasterFormY := 10;
    REIVX := 123;
    REIVY := 123;
    ColorFormX := 123;
    ColorFormY := 123;
    OptionsFormX := 123;
    OptionsFormY := 123;
    PrintersizeFormX := 123;
    PrintersizeFormY := 123;
    ResizeFormX := 123;
    ResizeFormY := 123;
    SystemInfoFormX := 123;
    SystemInfoFormY := 123;
    ImageInfoFormX := 123;
    ImageInfoFormY := 123;
    ViewCursorScreenX := 123;
    ViewCursorScreenY := 123;
    LabelObjectsFormX := 123;
    LabelObjectsFormY := 123;
    ObjectMarkFormX := 123;
    ObjectMarkFormY := 123;
    RotateFormX := 123;
    RotateFormY := 123;
    MagniFormX := 123;
    MagniFormY := 123;
    PBandHdrFormX := 123;
    PBandHdrFormY := 123;
    PBandsX := 123;
    PBandsY := 123;
    PBHisX := 123;
    PBHisY := 123;
    HistogramFormX := 123;
    HistogramFormY := 123;
    FormPrintX := 123;
    FormPrintY := 123;
    FEditFormX := 123;
    FEditFormY := 123;
    FFTFormX := 123;
    FFTFormY := 123;
    ClassificationFormX := 123;
    ClassificationFormY := 123;
    LinearFormX := 123;
    LinearFormY := 123;
    LineProfileFormX := 123;
    LineProfileFormY := 123;
    DistanceFormX := 123;
    DistanceFormY := 123;
    PixelAlgebraFormX := 123;
    PixelAlgebraFormY := 123;
    MacroFormX := 123;
    MacroFormY := 123;
    VRLabFormX := 123;
    VRLabFormY := 123;
    MoxelFormX := 123;
    MoxelFormY := 123;
    VoxelFormX := 123;
    VoxelFormY := 123;
    PixelFormX := 123;
    PixelFormY := 123;
    AboutBoxX := 123;
    AboutBoxY := 123;
    MessageX := 123;
    MessageY := 123;
{Reset Directories defaults  }
    RPM_Program := ExtractFilePath(ParamStr(0));
    FilterPath := {ExpandFileName}(RPM_Program {+ '\Filters\'});
    ImagePath := {ExpandFileName}(RPM_Program { +'Images\'});
    RPM_DEM := {ExpandFileName}(RPM_Program {+'DEM\'});
    RPM_Vectors := {ExpandFileName}(RPM_Program {+'Vectors\'});
    RPM_VDatabase := {ExpandFileName}(RPM_Program {+'V_Database\'});
    RPM_Storage := {ExpandFileName}(RPM_Program { +'Storage\'});
    ColorBlack := $00000000;
    ColorWhite := $00FFFFFF; {255,255,255} {White}
    ColorYELLOW := $0000BFBF; {YELLOW 191,191,0}
    ColorPURPLE := $00FE00FE; {254,0,254}
    ColorLYELLOW := $0000FEFE; {255,255,0}
    ColorDPURPLE := $007F007F; {128,0,128}
    Color1 := $00BF0000;
    Color2 := $00BFBF00;
    Color3 := $0000BF00;
    Color4 := $009F9FBF;
    Color5 := $00007FBF;
    Color6 := $009FBF9F;
    Color7 := $00BFAFBF;
    Color8 := $000000BF;
    Color9 := $00BFBFBF; {191,191,191: LIGHT GRAY [!]}
    CurrentColor := clBlack;
    UVW := $000F0000;
    VDW := $001F0000;
    VMW := $002F0000;
    VLW := $003F0000;
    UDW := $004F0000;
 {UUDBlueWater} UMW := $005F0000; {0,0,95} {ULTRA Dark Blue}
    ULW := $006F0000;
 {DkDBlueWater} DDW := $007F0000; {0,0,127} {Dark D Blue[!]}
 {DkMBlueWater} DMW := $008F0000; {0,0,143} {Dark M Blue[!]}
    DLW := $009F0000;
 {MDkBlueWater} MDW := $00AF0000; {0,0,175} {M Dark Blue[!]}
 {MdMBlueWater} MMW := $00BF0000; {0,0,191} {MEDIUM M Blue}
    MLW := $00CF0000;
    LDW := $00DF0000; {LtMBlueWater}
    LMW := $00EF0000; {0,0,239} {Light M Blue[!]}
    LLW := $00FE0000; {0,0,254} {LIGHT L Blue[!]}
    UVC := $000F0F00;
    VDC := $001F1F00;
    VMC := $002F2F00;
    VLC := $003F3F00;
    UDC := $004F4F00;
    UMC := $005F5F00;
    ULC := $006F6F00;
    DDC := $007F7F00; {0,143,143} {DARK M CYAN[!]}
    DMC := $008F8F00; {DkMBlueWetland}
    DLC := $009F9F00; {MdMBlueWetland}
    MDC := $00AFAF00; {0,191,191} {MEDIUM M CYAN}
    MMC := $00BFBF00;
    MLC := $00CFCF00;
 {LtMBlueWetland} LDC := $00DFDF00; {0,239,239} {LIGHT M CYAN[!]}
    LMC := $00EFEF00;
    LLC := $00FEFE00;

    UVF := $00000F00;
    VDF := $00001F00;
    VMF := $00002F00;
    VLF := $00003F00;
 {UDDGreenForest} UDF := $00004F00; {0,111,0}
    UMF := $00005F00;
    ULF := $00006F00;
 {DkMGreenForest} DDF := $00007F00; {0,143,0}
    DMF := $00008F00;
    DLF := $00009F00;
 {MdDGreenForest} MDF := $0000AF00; {0,175,0} {DARK GREEN [!]}
 {MdMGreenForest} MMF := $0000BF00; {0,191,0} {MEDIUM GREEN}
 {MdLGreenForest} MLF := $0000CF00; {0,207,0} {LIGHT GREEN[!]}
    LDF := $0000DF00;
 {LtMGreenForest} LMF := $0000EF00; {0,239,0}
 {LtMGreenForest} LLF := $0000FE00; {0,254,0}

    UVA := $0001010F;
    VDA := $0005051F;
    VMA := $000F0F2F;
    VLA := $001F1F3F;
    UDA := $002F2F4F;
 {UUAgricultural} UMA := $003F3F5F; {95,63,63} {UU BROWN}
 {UDAgricultural} ULA := $004F4F6F; {111,79,79} {UD BROWN}
 {UDAgricultural} DDA := $005F5F7F; {127,95,95} { BROWN}
 {DDAgricultural} DMA := $006F6F8F; {143,111,111} {BROWN }
 {DKAgricultural} DLA := $007F7F9F; {159,127,127} {BROWN }
 {DMAgricultural} MDA := $008F8FAF; {175,143,143} {BROWN }
 {MdAgricultural} MMA := $009F9FBF; {191,159,159} {BROWN }
 {LMAgricultural} MLA := $00AFAFCF; {207,175,175} {BROWN }
 {LtAgricultural} LDA := $00BFBFDF; {223,191,191} {BROWN }
 {LLAgricultural} LMA := $00CFCFEF; {239,207,207} {BROWN }
 {ULAgricultural} LLA := $00DFDFFE; {254,223,223} {BROWN }

    UVR := $0000030F;
    VDR := $0000071F;
    VMR := $0000102F;
    VLR := $0000133F;
    UDR := $00000F4F;
    UMR := $00001F5F;
    ULR := $00002F6F;
 {DkMRangeland} DDR := $00003F7F; {143,79,0} {DARK M ORANGE}
    DMR := $00004F8F;
    DLR := $00005F9F;
 {MdMRangeland} MDR := $00006FAF; {191,127,0} {MEDIUM M ORANGE}
    MMR := $00007FBF;
    MLR := $00008FCF;
 {LtMRangeland} LDR := $00009FDF; {239,175,0} {LIGHT M ORANGE}
    LMR := $0000AFEF;
    LLR := $0000BFFE;

    UVT := $00060F06;
    VDT := $00121F12;
    VMT := $000F2F0F;
    VLT := $001F3F1F;
    UDT := $002F4F2F;
    UMT := $003F5F3F;
    ULT := $004F6F4F;
 {DkMGrayTundra} DDT := $005F7F5F; {111,143,111} {dark M Ggray}
    DMT := $006F8F6F;
    DLT := $007F9F7F;
 {MdMGrayTundra} MDT := $008FAF8F; {159,191,159} {medium M Ggray}
    MMT := $009FBF9F;
    MLT := $00AFCFAF;
 {LtMGrayTundra} LDT := $00BFDFBF; {207,239,207} {light M Ggray}
    LMT := $00CFEFCF;
    LLT := $00DFFEDF; {223,254,223}

    UVB := $000F060F;
    VDB := $001F0F1F;
    VMB := $002F1F2F;
    VLB := $003F2F3F;
    UDB := $004F3F4F;
    UMB := $005F4F5F;
    ULB := $006F5F6F;
 {DkMBarren} DDB := $007F6F7F; {143,127,143} {DARK M P_GRAY}
    DMB := $008F7F8F;
    DLB := $009F8F9F;
 {MdMBarren} MDB := $00AF9FAF; {191,175,191} {MEDIUM M P_GRAY}
    MMB := $00BFAFBF;
    MLB := $00CFBFCF;
 {LtMBarren} LDB := $00DFCFDF; {239,223,239} {LIGHT M P_GRAY}
    LMB := $00EFDFEF;
    LLB := $00FEEFFE; {254,239,254}

    UVU := $0000000F;
    VDU := $0000001F;
    VMU := $0000002F;
    VLU := $0000003F;
    UDU := $0000004F;
    UMU := $0000005F;
 {UDkRedUrban} ULU := $0000006F; {95,0,0} {DARK U RED[!]}
 {DDkRedUrban} DDU := $0000007F; {127,0,0} {DARK D RED[!]}
 {DkMRedUrban} DMU := $0000008F; {143,0,0} {DARK M RED[!]}
 {DkLRedUrban} DLU := $0000009F; {159,0,0} {DARK L RED[!]}
 {MdMRedUrban} MDU := $000000AF; {191,0,0} {MEDIUM M RED}
    MMU := $000000BF;
    MLU := $000000CF;
 {LtDRedUrban} LDU := $000000DF; {223,0,0} {LIGHT D RED[!]}
 {LtMRedUrban} LMU := $000000EF; {239,0,0} {LIGHT M RED[!]}
 {LLtRedUrban} LLU := $000000FE; {254,0,0} {LIGHT L RED[!]}

    UVS := $000F0F0F;
    VDS := $001F1F1F;
    VMS := $002F2F2F;
    VLS := $003F3F3F;
    UDS := $004F4F4F;
    UMS := $005F5F5F;
    ULS := $006F6F6F;
 {DkMWhiteSnow} DDS := $007F7F7F; {143,143,143} {Dark M white}
    DMS := $008F8F8F;
    DLS := $009F9F9F;
 {MdMWhiteSnow} MDS := $00AFAFAF; {191,191,191} {medium M white}
    MMS := $00BFBFBF;
    MLS := $00CFCFCF;
    LDS := $00DFDFDF;
 {LtMWhiteSnow} LMS := $00EFEFEF; {239,239,239} {off M white}
 {ULtWhiteSnow} LLS := $00FEFEFE; {254,254,254} {off M white}
 {Snow or Ice? Black or White is NOT Classified items?}
    OpenWithPreview := True;
    SaveWithPreview := True;

    DisplayConvert32:= True;
    CurrentColor := clBlack;
    VoicesON := False;
    DoneBeepOn := False;
    ErrorBeepOn := False;
    ErrorVoiceOn := False;
    R_AutoTT := False;
    V_Absolute := False;
    dAT_Min := 0;
    dAT_Max := 255;
    AUTORANGE := False;
    S_Threshold := False;
    bST_Max := 255;
    bST_Min := 0;
    ClipR := True;
    Do_Ex_Com := False;
    BelowZero := False;
    ObjectMarkingOn := False;
    ObjectMarking := False;
    Toggle_D_RGB := FALSE;
    Toggle_D_R := FALSE;
    Toggle_D_G := FALSE;
    Toggle_D_B := True;
    DoSaver;
  end;
  top := RasterFormY;
  left := RasterFormX;
  Loading:= FALSE;
  MMSysHandle := LoadLibrary('WINMM.DLL');
  if (MMSysHandle <> 0) then
  begin
    @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySoundA');
  end else
  begin
    MMSysHandle := LoadLibrary('MMSYSTEM.DLL');
    if (MMSysHandle <> 0) then
    begin
      @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySound');
    end;
  end;
  if (MMSysHandle = 0) then
  begin
    ShowMessage('Cannot locate WINMM.DLL or MMSYSTEM.DLL.. no sounds');
{SoundDllLocated:=False;}
  end {else  SoundDllLocated:=True};

{Get App Location to load Help}
  Helps := ExtractFilePath(ParamStr(0));
  Helps := Helps + 'Grip.HLP';
  Application.HelpFile := Helps;
  Application.Title := 'GRIP ICE';
  Application.OnHint := ShowHint;
  MagnifierSize := 32;
  FormControl:=0;
  Processing:=False;
  WandingOn:=False;
    
  REIVFormActive:=False;
  SystemInfoFormActive:=False;
  FrInfoActive:=False;
  PrintersizeFormActive:=False;
  HistogramFormActive:=False;
  LinearFormActive:=False;
  PixelAlgebraFormActive:=False;
  FEditFormActive:=False;
  ClassificationFormActive:=False;
  LabelObjectsFormActive:=False;
  ObjectMarkFormActive:=False;
  PBandHdrFormActive:=False;
LineProfileFormActive:=False;
DisProcessFormActive:=False;
  DoingBigTimeRegistration:=False;
 {Set up Menu to defaults}
  Do_MenuDefaults;
  Do_LoadedEnable(False);
  Do_ExtraEnable(False);
  UndoBtn.Enabled := False;
  I_Undo.Enabled := False;
  if ParamCount = 1 then
    if UpperCase(ExtractFileExt(ParamStr(1))) = '.PNG' then
    begin
      ImagePath := ExtractFilePath(ParamStr(1));
      GRIPFileName := ExtractFileName(ParamStr(1));
      LoadFromFile(GRIPFileName);
    end;
  NotYetShown := True;
end;

procedure TGRIPForm.Do_MenuDefaults;
begin
  Toggle_D_Rotate := FALSE; {ALWAYS FALSE}
  All_Max := 0; {USED for info display not set...}
  All_Min := 255;
  ImageMade := False;
  ImageLoaded := False;
  StartCropping := False;
  Cropping := False;
  StartCropping256 := False;
  CropTo_256 := False;
  StartCropping512 := False;
  CropTo_512 := False;
  StartCropping1024 := False;
  CropTo_1024 := False;
  DO_RGBRotate := False;
  bCMYK := False; {Switch operates inside RGBRotate}
  DO_RGBNegRotate := False;
 {} bStartTraining := FALSE;
  bTraining := FALSE;
  LoggingToDIP := FALSE;
  LogtoDIP.Checked := False;
  LoggingToMacro := FALSE;
  PlayingMacro := FALSE;
  ImageClassed := FALSE;
  Count3DFileExists := FALSE;
  CountFileExists := FALSE;
  Stats3DFileExists := FALSE;
  StatsFileExists := FALSE;
  Counter := 1;
{    IsNewFile := FALSE;}
  MyChanged := FALSE;
  IsModified := FALSE;

  Image_Add := False;
  Image_Subtract := False;
  ViewCursorOn := FALSE;
  ViewCursorOnReally := FALSE;
  ToggleOn := FALSE;
  ProfileDrawing := FALSE;
  Profiling := FALSE;
  ProfileLineDrawing := FALSE;
{  ZoomOn :=FALSE;
  bWindowFit := FALSE;
  bSnapFrame := FALSE;  }
 { ButtonDown := FALSE;}
  StartDrawing := FALSE;
  Drawing := FALSE;
end;

{---------------------------------------------------------------------}
{------------------------------------------------------------------------}

procedure TGRIPForm.ShowHint(Sender: TObject);
begin
  StatusBar1.Panels[0].Text := Application.Hint;
end;
{---------------------------------------------------------------------}

procedure TGRIPForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  S: string;
begin
  RasterFormY := GRIPForm.top;
  RasterFormX := GRIPForm.left;
  DoSaver;
  if IsModified then
  begin
    if GRIPFileName = '' {nil} then
      S := 'Untitled file has changed. Save?'
    else S := 'File: ' + GRIPFileName + ' has changed.  Save?';
    if (MessageDlgPos(S,
      mtInformation, [mbYes, mbNo], 0,
      MessageX,
      MessageY) = mrYes)
      then
    begin
      if GRIPFileName = '' {nil} then
      begin
        GRIPFileName := 'noname.png';
        F__SaveasClick(Sender);
      end else F_SaveClick(Sender);
    end;
  end;
  CanClose := True;
end;
{--------------------------------------------------}
procedure TGRIPForm.FreeForm;
Begin
  Timer1.Enabled:=True;
End;

procedure TGRIPForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False;
  Case FormControl of
{  1:Begin If REIVFormActive then REIVForm.Free; REIVFormActive:=False; End;}
  2:Begin If SystemInfoFormActive then SystemInfoForm.Free; SystemInfoFormActive:=False; End;
  3:Begin If FrInfoActive then FrInfo.Free; FrInfoActive:=False; End;
  4:Begin If PrintersizeFormActive then PrintersizeForm.Free; PrintersizeFormActive:=False; End;
 { 5:Begin If HistogramFormActive then HistogramForm.Free; HistogramFormActive:=False; End;}
{  6:Begin If LinearFormActive then LinearForm.Free; LinearFormActive:=False; End;}
  7:Begin If PixelAlgebraFormActive then PixelAlgebraForm.Free; PixelAlgebraFormActive:=False; End;
  8:Begin If FEditFormActive then FEditForm.Free; FEditFormActive:=False; End;
  9:Begin If ClassificationFormActive then ClassificationForm.Free; ClassificationFormActive:=False; End;
  10:Begin If LabelObjectsFormActive then LabelObjectsForm.Free; LabelObjectsFormActive:=False; End;
  11:Begin If ObjectMarkFormActive then ObjectMarkForm.Free; ObjectMarkFormActive:=False; End;
 { 12:Begin If LineProfileFormActive then LineProfileForm.Free; LineProfileFormActive:=False; End;}
 { 13:Begin If DisProcessFormActive then DisProcessForm.Free; DisProcessFormActive:=False; End;}
  14:Begin If FFTFormActive then FFTForm.Free; FFTFormActive:=False; End;
 { 15:Begin If PBandHdrFormActive then PBandHdrForm.Free; PBandHdrFormActive:=False; End;}
  end;
end;

procedure TGRIPForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin
  RasterFormX := GRIPForm.left;
  RasterFormY := GRIPForm.top;
  DoSaver;
  SetLength(ObjectMarkerArray, 0);
  SetLength(ObjectLabelArray, 0);
  SetLength(RegArray,0);
  if ImageLoaded then UnLoadImage;
  if MakeBitmapRotate then Do_DeleteBitmapRotate;
  Application.ProcessMessages;
  Action := caFree;
end;

procedure TGRIPForm.F_ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TGRIPForm.AboutBoxBtnClick(Sender: TObject);
begin
  AboutGrip := TAboutGrip.Create(Application);
  If AboutGrip.Showmodal= mrOK then AboutGrip.Free
  else AboutGrip.Free;
end;

procedure TGRIPForm.HelpButtonClick(Sender: TObject);
begin
  Application.HelpContext(0);
end;
{------------------------------------------------------------------------}
{For this to work with scroll bars, etc...
Image must be set in Object Inspector to:
Align alNone
Autosize True
Center false
Stretch  False
StretchRatio False}

procedure TGRIPForm.F_OpenClick(Sender: TObject);
begin
  if OpenWithPreview then
  begin
    LoadFileDialog.InitialDir := ImagePath;
    LoadFileDialog.Filter := 'All (*.bmp;*.png)|*.bmp;*.png';
    if LoadFileDialog.Execute then
    begin
      ImagePath := ExtractFilePath(LoadFileDialog.Filename);
      GRIPFileName := ExtractFileName(LoadFileDialog.Filename);
      LoadFromFile(GRIPFileName);
      if LoggingToMacro then
      begin
        MacroForm.MacroRE.Lines.Add('=0003  Open');
        MacroForm.MacroRE.Lines.Add(ImagePath);
        MacroForm.MacroRE.Lines.Add(GRIPFileName);
      end;
    end;
  end else
  begin
    OpenDialog.InitialDir := ImagePath;
    OpenDialog.Filter := 'All (*.bmp;*.png)|*.bmp;*.png';
    if OpenDialog.Execute then
    begin
      ImagePath := ExtractFilePath(OpenDialog.Filename);
      GRIPFileName := ExtractFileName(OpenDialog.Filename);
      LoadFromFile(GRIPFileName);
      if LoggingToMacro then
      begin
        MacroForm.MacroRE.Lines.Add('=0003  Open');
        MacroForm.MacroRE.Lines.Add(ImagePath);
        MacroForm.MacroRE.Lines.Add(GRIPFileName);
      end;
    end;
  end;
end;

{Load a file}

procedure TGRIPForm.LoadFromFile(Filename: string);
var
  LoadedOK:Boolean;
  PNG:TPNGObject;
  MtnString: string;
begin
  LoadedOK:=False;
  LastPos := 0;
  Loading := TRUE;
  GRIPForm.Cursor :=CRHOURGLASS;
  Application.ProcessMessages;
  if ImageLoaded then begin
    UnLoadImage;
    HistogramForm.DisableAllNewFile;
    HistogramForm.DisableAll;
  end;
  {FillRect(Image1.Picture.Bitmap.Canvas.Handle, ClientRect,
    COLOR_BTNFACE + 1);}
  {Load the image}
  if (lowercase(extractfileext(Filename)) = '.bmp') then
  begin
    try
    Image1.Picture.LoadFromFile(ImagePath + Filename);
    LoadedOK:=True;
    finally end;
  end else
  if (lowercase(extractfileext(Filename)) = '.png') then
  begin
    PNG := TPNGObject.Create;
    {BMP := TBitmap.Create; }
    {In case something goes wrong, free both PNG and Bitmap}
    try
      {Image2.Picture.Bitmap.PixelFormat := pf24bit;
      PNG.Assign(TBitmap(Image2.Picture.Graphic));}
      PNG.LoadFromFile(ImagePath + Filename);
{      Image1.Picture.Bitmap.PixelFormat := pf32bit;}
      Image1.Picture.Bitmap.Assign(PNG); //Convert data into bitmap
      LoadedOK:=True;
    finally
      PNG.Free;
      {BMP.Free;}
    end;
    {Image1.Picture.LoadFromFile(FilePath + Filename); }
  end;
  If LoadedOK then
  BEGIN
  if (Image1.Picture.Bitmap.PixelFormat <> pf24bit) then
  begin
    if (Image1.Picture.Bitmap.PixelFormat = pf4bit)
      then DoMessages(41);
    if (Image1.Picture.Bitmap.PixelFormat = pf8bit)
      then DoMessages(42);
    if (Image1.Picture.Bitmap.PixelFormat = pf15bit)
      then DoMessages(43);
    if (Image1.Picture.Bitmap.PixelFormat = pf16bit)
      then DoMessages(44);
    if (Image1.Picture.Bitmap.PixelFormat = pf32bit)
      then DoMessages(45);
    Image1.Picture.Bitmap.PixelFormat := pf24bit;
  end;
  Progress(0);
  {Set the file panel}
  StatusBar1.Panels[0].Text := (Filename);
  if Image1.Picture.Graphic is TPNGObject then
    PngInfo1.Enabled := True
  else PngInfo1.Enabled := False;
  {StatusBar1.Panels[1].Text := format('%n s', [(GetTickCount - Tempo)
    / 1000]);}
  Loading := FALSE;
  Image1.Canvas.Draw(0{(Width div 2) - (Image1.Picture.Width div 2)},
    0 {((Height) div 2) - (Image1.Picture.Height div 2)},
    Image1.Picture.Graphic);
  with ScrollBox1.HorzScrollBar do
  begin
    Increment := 4;
    Position := 0;
    Range := Image1.Width;
    Visible := True;
  end;
  with ScrollBox1.VertScrollBar do
  begin
    Increment := 4;
    Position := 0;
    Range := Image1.Height;
    Visible := True;
  end;

  StatusBar1.Panels[1].Text := 'Loading Image and Stats';
  Application.ProcessMessages;
  myLoadImage;
  if ImageLoaded then begin
    SetFileName(Filename);
    Do_LoadedEnable(True);
    Do_ExtraEnable(True);
    Do_Stat;
    MtnString := ChangeFileExt(Filename, '.DIP');
    if (FileExists(ImagePath + MtnString)) then
      PBands.RIHOpenDIPHeader(MtnString) else
      PBands.RIHMakeAllHeaders(MtnString, Image1.Width,
        Image1.Height);
  end;
  {  Screen.Cursor:=CRDEFAULT;     }
  END;
  GRIPForm.Cursor := CRDEFAULT;
  Application.ProcessMessages;
end;

(*
{Loading progress}
procedure TGRIPForm.ImageProgress(Sender: TObject; Stage:
  TProgressStage;
  PercentDone: Byte; RedrawNow: Boolean; const R: TRect;
  const Msg: string);
begin
{If it is a TPNG image we can show it progressive}
  if Sender is TPNGObject then
  begin
    Progress(PercentDone);
    if (PercentDone mod 5 = 0) and
      (TChunkIHDR(TPNGObject(SENDER).Chunks[0]).Interlaced = 0) then
    begin
      BitBlt(Image1.Picture.Bitmap.Canvas.Handle,
        (Width - TBitmap(Sender).Width) div 2,
        ((Height - TBitmap(Sender).Height) div 2) + LastPos,
        R.Right,
        R.Bottom - LastPos,
        TBitmap(Sender).Canvas.Handle, 0, LastPos, SRCCOPY);
      LastPos := R.Bottom;
    end
    else if (TChunkIHDR(TPNG5IMAGE(SENDER).Chunks[0]).Interlaced = 1)
      then
      Image1.Picture.Bitmap.Canvas.Draw((Width -
        TBitmap(Sender).Width) div 2,
        ((Height) - TBitmap(Sender).Height) div 2, TBitmap(sender));
  end;
  Application.Processmessages;
end;
*)
{Change the value of the progress area}

procedure TGRIPForm.Progress(Value: Byte);
begin
  {Ensures that the value does not pass 100}
  if Value > 100 then
    Value := 100;
  {Set the panel text}
  Gauge1.Progress := Value;
  StatusBar1.Panels[1].Text := INTTOSTR(Value);
end;
{-------------------------------------------------------------}
{-------------------------------------------------------------}

procedure TGRIPForm.F_SaveClick(Sender: TObject);
begin
(*  if NotYetShown then
  begin
    {14748364 Entered in About Box}
    if (MapBaseColor <> 14748364)  then
    begin
      if (Started < (Now - 64)) then
      begin {    AboutGrip.Show;}
        AboutGrip := TAboutGrip.Create(Application);
        If AboutGrip.Showmodal= mrOK then AboutGrip.Free
        else AboutGrip.Free;
        if (MapBaseColor <> 14748364) then
        begin
          DoMessages(30001);
          //Application.Terminate;
        end;
      end;
      if (Started < (Now - 31)) then
      begin
        DoMessages(20004);
      end;
    end; {Registered}
  end; {not yet} {Show Once per app run  AboutGrip.Showmodal;}
  Gauge1.Progress := 0;
  NotYetShown := False;
*)     Gauge1.Progress := 0;
  SaveImage;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0005   Save');
    MacroForm.MacroRE.Lines.Add(ImagePath);
    MacroForm.MacroRE.Lines.Add(GRIPFileName);
  end;
end;

procedure TGRIPForm.SaveNumbered1Click(Sender: TObject);
begin
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0004  SaveNumbered');
    MacroForm.MacroRE.Lines.Add(ImagePath);
    MacroForm.MacroRE.Lines.Add(GRIPFileName);
  end;
  NumberName;
  SaveImage;
end;
{---------------------------------------------------------------------}

procedure TGRIPForm.SaveImage;
var
 PNG: TPNGObject;
 tempath: string;
begin
  tempath := ImagePath + GRIPFileName;
  if Image1.Picture.Graphic = nil then
  begin
    DoMessages(46);
    exit;
  end;
  GRIPForm.Cursor := crHourGlass;
  Application.ProcessMessages;
  if (lowercase(extractfileext(GRIPFileName)) = '.bmp') then
  begin
    Image1.Picture.Bitmap.PixelFormat := pf24bit;
    Image1.Picture.Graphic.SaveToFile(tempath);
  end else
  if (lowercase(extractfileext(GRIPFileName)) = '.png') then
  begin
    PNG := TPNGObject.Create;
    {BMP := TBitmap.Create; }
    {In case something goes wrong, free both PNG and Bitmap}
    try
      Image1.Picture.Bitmap.PixelFormat := pf24bit;
      PNG.Assign(TBitmap(Image1.Picture.Graphic)); //Convert data into png
      PNG.SaveToFile(tempath);
      finally
      PNG.Free;
    end;
  end;
  GRIPForm.Cursor := CRDEFAULT;
  Application.ProcessMessages;
end;

{---------------------------------------------------------------------}

{---------------------------------------------------------------------}
{Reverse this so AFTER the filename is chosen from Dialog
THEN the type of file is chosen...
NO changing type after the ball is rolling}

procedure TGRIPForm.F__SaveasClick(Sender: TObject);
var temp, tempath: string;
{  jp: TJpegImage; }//Requires the "jpeg" unit added to "uses" clause.
begin
  tempath := ImagePath + GRIPFileName;
  temp := ExtractFileExt(tempath);
  SaveDialog1.FileName := tempath;
  SavePictureDialog1.FileName := tempath;
  if ((temp = '.PNG') or (temp = '.png')or
      (temp = '.BMP') or (temp = '.bmp')) then
  begin
    if SaveWithPreview then
    begin
{set SaveDialog filter to display png's only}
      SavePictureDialog1.filter := 'BMP PNG files|*.BMP;*.PNG';
      SavePictureDialog1.DefaultExt := 'PNG';
      if SavePictureDialog1.Execute then {Save it}
      begin
        temp := ExtractFileExt(SavePictureDialog1.FileName);
        if ((temp = '.PNG') or (temp = '.png')or
            (temp = '.BMP') or (temp = '.bmp')) then
        begin
          GRIPFileName := ExtractFileName(SavePictureDialog1.FileName);
          ImagePath := ExtractFilePath(SavePictureDialog1.FileName);
          SetFileName(GRIPFileName);
          SaveImage;
          if LoggingToMacro then
          begin
            MacroForm.MacroRE.Lines.Add('=0002 Saveas');
            MacroForm.MacroRE.Lines.Add(ImagePath);
            MacroForm.MacroRE.Lines.Add(GRIPFileName);
          end;
        end;
      end;
    end  else
    begin
      {set SaveDialog filter to display png's only}
      SaveDialog1.filter := 'BMP PNG files|*.PNG;*.BMP';
      SaveDialog1.DefaultExt := 'PNG';
      if SaveDialog1.Execute then {Save it}
      begin
        temp := ExtractFileExt(SaveDialog1.FileName);
          if ((temp = '.PNG') or (temp = '.png') or
              (temp = '.BMP') or (temp = '.bmp')) then
        begin
            GRIPFileName := ExtractFileName(SaveDialog1.FileName);
            ImagePath := ExtractFilePath(SaveDialog1.FileName);
            SetFileName(GRIPFileName);
            SaveImage;
          if LoggingToMacro then
          begin
              MacroForm.MacroRE.Lines.Add('=0002 Saveas');
              MacroForm.MacroRE.Lines.Add(ImagePath);
              MacroForm.MacroRE.Lines.Add(GRIPFileName);
          end;
        end;
      end;
    end;
    Gauge1.Progress := 0;
  end else showmessage('File type unk');
end;
{---------------------------------------------------------------------}

{------------------------------------------------------------------------}

procedure TGRIPForm.FS_BMPClick(Sender: TObject);
var
  tempath: string;
  Bitmap: TBitmap;
begin
  if SaveWithPreview then
  begin
    tempath := ImagePath + GRIPFileName;
    SavePictureDialog1.FileName := ChangeFileExt(tempath, '.bmp');
    SavePictureDialog1.filter := 'BMP files|*.bmp';
  {set SaveDialog Default extension}
    SavePictureDialog1.DefaultExt := 'bmp';
    if SavePictureDialog1.Execute then
    begin
      GRIPForm.Cursor := crHourGlass;
      Application.ProcessMessages;
      tempath := ExtractFileExt(SavePictureDialog1.FileName);
      if ((tempath = '.BMP') or (tempath = '.bmp')) then
      begin
        {Save it}
        Bitmap := TBitmap.Create;
        Bitmap.Width := Image1.Picture.Graphic.Width;
        Bitmap.Height := Image1.Picture.Graphic.Width;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        Bitmap.Assign(Image1.Picture.Bitmap);
        Bitmap.SaveToFile(SavePictureDialog1.Filename);
        Bitmap.Free;
        {reset the gauge to 0}
        Gauge1.Progress := 0;
      end;
    end;
  end else
  begin
    tempath := ImagePath + GRIPFileName;
    SaveDialog1.FileName := ChangeFileExt(tempath, '.bmp');
    SaveDialog1.filter := 'BMP files|*.bmp';
    {set SaveDialog Default extension}
    SaveDialog1.DefaultExt := 'bmp';
    if SaveDialog1.Execute then
    begin
      GRIPForm.Cursor := crHourGlass;
      Application.ProcessMessages;
      tempath := ExtractFileExt(SaveDialog1.FileName);
      if ((tempath = '.BMP') or (tempath = '.bmp')) then
      begin
        {Save it}
        Bitmap := TBitmap.Create;
        Bitmap.Width := Image1.Picture.Graphic.Width;
        Bitmap.Height := Image1.Picture.Graphic.Width;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        Bitmap.Assign(Image1.Picture.Bitmap);
        Bitmap.SaveToFile(SaveDialog1.Filename);
        Bitmap.Free;
        {reset the gauge to 0}
        Gauge1.Progress := 0;
      end; end;
  end;
  {reset the gauge to 0}
      Gauge1.Progress := 0;
  GRIPForm.Cursor := crDefault;
  Application.ProcessMessages;
end;

procedure TGRIPForm.FS_JPGClick(Sender: TObject);
var tempath: string;
  jp: TJpegImage; //Requires the "jpeg" unit added to "uses" clause.
begin
  if SaveWithPreview then
  begin
    tempath := ImagePath + GRIPFileName;
    SavePictureDialog1.FileName := ChangeFileExt(tempath, '.jpg');
    SavePictureDialog1.filter := 'Jpeg files|*.jpg';
    SavePictureDialog1.DefaultExt := 'jpg';
    if SavePictureDialog1.Execute then
    begin
      GRIPForm.Cursor := crHourGlass;
      Application.ProcessMessages;
      tempath := ExtractFileExt(SavePictureDialog1.FileName);
      if ((tempath = '.JPG') or (tempath = '.jpg')) then
      begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
            Image1.Picture.Bitmap.PixelFormat := pf24bit;
            Assign(Image1.Picture.Bitmap);
            SaveToFile(SavePictureDialog1.Filename)
          end;
        finally
          jp.Free;
        end;
      end;
  {reset the gauge to 0}
      Gauge1.Progress := 0;
    end;
  end else
  begin
    tempath := ImagePath + GRIPFileName;
    SaveDialog1.FileName := ChangeFileExt(tempath, '.jpg');
    SaveDialog1.filter := 'Jpeg files|*.jpg';
    SaveDialog1.DefaultExt := 'jpg';
    if SaveDialog1.Execute then
    begin
      GRIPForm.Cursor := crHourGlass;
      Application.ProcessMessages;
      tempath := ExtractFileExt(SaveDialog1.FileName);
      if ((tempath = '.JPG') or (tempath = '.jpg')) then
      begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
            Image1.Picture.Bitmap.PixelFormat := pf24bit;
            Assign(Image1.Picture.Bitmap);
            SaveToFile(SaveDialog1.Filename)
          end;
        finally
          jp.Free;
        end;
      end;
    end;
  end;
  {reset the gauge to 0}
      Gauge1.Progress := 0;
      GRIPForm.Cursor := crDefault;
      Application.ProcessMessages;
end;

(******************************************************)
(******************************************************)

procedure TGRIPForm.FormResize(Sender: TObject);
begin
  ScrollBox1.Height := (GRIPForm.ClientHeight - 2);
    {    303 276    274}
  ScrollBox1.Width := (GRIPForm.ClientWidth - 62);
    {    434  426    364}
end;


{---------------------------------------------------------------------}

procedure TGRIPForm.MultiImage1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var NamedStatS: string;
  ImageWidthi, ImageHeighti, i: integer;
begin
  ImageWidthi := ImageWidth;
  ImageHeighti := ImageHeight;
  if button = mbLeft then
  begin
    {Grab screen pixels and display as text}
    if (ViewCursorOn) then
    begin
      if ((X > 0) and (X < (ImageWidthi - 25))) then
        pointStart.X := X else pointStart.X := 0;
      if ((Y > 0) and (Y < (ImageHeighti - 25))) then
        pointStart.Y := Y else pointStart.Y := 0;
      pointEnd.X := (pointStart.X + 25);
      pointEnd.Y := (pointStart.Y + 25);
      DrawRubberband;
      ViewCursorOnReally := True;
      Screen.Cursor := crNone;
    end else
    if Profiling then
    begin
      ProfileDrawing := True;
      LineProfileForm.DoImageMouseDown(X, Y);
    end else
    if Toggle_D_Rotate then
    begin
      Inc(WhichS); if WhichS > 9 then WhichS := 0;
      { UndoImage; MakeImage; DoImStats(WhichS);         }
      for i := 0 to 9 do ClassesR[i] := RedStats[WhichS, i];
          for i := 0 to 9 do ClassesG[i] := GreenStats[WhichS, i];
          for i := 0 to 9 do ClassesB[i] := BlueStats[WhichS, i];
          DO_Stats(WhichS);
          case WhichS of
       {How to load strings... ONCE... load when Rotate selected}
            0: NamedStatS := 'Natural Break Class';
       {Natural Break Class Computed}
            1: NamedStatS := 'Best Fit Class';
            2: NamedStatS := 'Steps Class';
            3: NamedStatS := 'Area Class';
            4: NamedStatS := 'Mean SD';
            5: NamedStatS := 'Median SD';
      {Range}
            6: NamedStatS := 'Arithmatic';
            7: NamedStatS := 'Geometric';
            8: NamedStatS := 'Geo Decreasing';
            9: NamedStatS := 'ArithID';
            10: NamedStatS := 'ArithDC';
            11: NamedStatS := 'ArithDI';
            12: NamedStatS := 'ArithDD';
            14: NamedStatS := 'GeomII';
            15: NamedStatS := 'GeomID';
            16: NamedStatS := 'GeomDC';
            17: NamedStatS := 'GeomDI';
            18: NamedStatS := 'GeomDD';
          end; {of Case}
          {SetFileName(ExtractFileName(OpenDialog1.filename));}
          GRIPForm.Caption := GRIPForm.Caption + NamedStatS;
    end else
    if DO_RGBRotate then
    begin
      Do_TheRotate;
    end else
    if DO_RGBNegRotate then begin
       Do_TheRotate;
    end else
    if (ObjectMarking) then
    begin {ObjectMarking}
      if (not ObjectMarkingOn) then
      begin
                  ObjectMarkingOn := True;
                  pointStart.X := X;
                  pointStart.Y := Y;
                  pointEnd.X := X;
                  pointEnd.Y := Y;
      end;
    end else
    if (StartDrawing) then begin {Linear Measured}
      if (not Drawing) then
      begin
                    Drawing := True;
                    pointStart.X := X;
                    pointStart.Y := Y;
                    pointEnd.X := X;
                    pointEnd.Y := Y;
      end;
    end else
    if (bStartTraining) then begin {Classification}
      if (not bTraining) then begin
                      bTraining := True;
                      pointStart.X := X;
                      pointStart.Y := Y;
                      pointEnd.X := X;
                      pointEnd.Y := Y;
      end;
    end;
  end;
end;
{---------------------------------------------------------------------}

procedure TGRIPForm.MultiImage1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var BlueCS, RedCS, GreenCS, XStr, YStr: string;
  dc: hdc; BlueC, RedC, GreenC: Byte;
  Colors: TColorRef; Xword, Yword: Dword;
  ImageWidthi, ImageHeighti: integer;
begin
  ImageWidthi := ImageWidth;
  ImageHeighti := ImageHeight;
  Xword := X; Yword := Y;
  if (ViewMagniOn) then
  begin
    if ((X > MagnifierSize) and (X < (ImageWidthi - MagnifierSize)
          -1)) then
    begin
      pointStart.X := X - MagnifierSize;
    end else
    begin
      if (X < MagnifierSize) then pointStart.X := 0
      else if (X > (ImageWidthi - MagnifierSize) - 1)
        then pointStart.X := (ImageWidthi - (MagnifierSize * 2)) - 1;
    end;
    if ((Y > MagnifierSize) and (Y < (ImageHeighti - MagnifierSize) - 1)) then
    begin
      pointStart.Y := Y - MagnifierSize;
    end else
    begin
      if (Y < MagnifierSize) then pointStart.Y := 0
      else if (Y > (ImageHeighti - MagnifierSize) - 1)
        then
        pointStart.Y := (ImageHeighti - (MagnifierSize * 2)) - 1;
    end;
    MagniForm.ShowMagnifier(pointStart.X, pointStart.Y);
    str(X, XStr); str(Y, YStr);
    dc := GetDc(0);
    Colors := GetPixel(dc, X, Y);
    BlueC := GetBValue(Colors); Str(BlueC, BlueCS);
    RedC := GetRValue(Colors); Str(RedC, RedCS);
    GreenC := GetGValue(Colors); Str(GreenC, GreenCS);
    ReleaseDc(0, dc); {Give back the screen dc}
    StatusBar1.Panels.items[1].Text :=
      'X: ' + XStr + ' Y: ' + YStr + ' B: ' + BlueCS + ' G: ' +
      GreenCS + ' R: ' + RedCS;
  end else
  if (ViewCursorOnReally) then
  begin
      DrawRubberband;
      if ((Xword > 0) and (Xword < (ImageWidth - 25))) then
        pointStart.X := Xword else pointStart.X := 0;
      if ((Yword > 0) and (Yword < (ImageHeight - 25))) then
        pointStart.Y := Yword else pointStart.Y := 0;
      pointEnd.X := (pointStart.X + 25);
      pointEnd.Y := (pointStart.Y + 25);
      DrawRubberband;
  end else
  if ProfileDrawing then
  begin
        LineProfileForm.DoImageMouseMove(X, Y);
  end else
  if ObjectMarkingOn then begin {Object Marking}
          DrawRubberMark;
          pointEnd.x := X;
          pointEnd.y := Y;
          DrawRubberMark;
  end else
  if Drawing then begin {KB or Line Mouser}
            DrawRubberband;
            pointEnd.x := X;
            pointEnd.y := Y;
            DrawRubberband;
  end else
  if bTraining then begin {Classification}
              DrawRubberband;
              pointEnd.x := X;
              pointEnd.y := Y;
              DrawRubberband;
  end else
  If bLeftDown then begin {MultiImage mouser}
                DrawRubberband;
                pointEnd.x := X;
                pointEnd.y := Y;
                DrawRubberband;
  end else begin {Text out the Cursor pixel colors}
                str(X, XStr); str(Y, YStr);
  {  dc := GetDc(0);  }
   { Colors:=  GetPixel(dc,X,ImageHeighti-Y); }
                Colors := Image1.Canvas.Pixels[X, Y];
                BlueC := GetBValue(Colors); Str(BlueC, BlueCS);
                RedC := GetRValue(Colors); Str(RedC, RedCS);
                GreenC := GetGValue(Colors); Str(GreenC, GreenCS);
    {dc := }{ReleaseDc(0, dc);}{Give back the screen dc}
                StatusBar1.Panels.items[1].Text :=
                  'X: ' + XStr + ' Y: ' + YStr + ' B: ' + BlueCS +
                  ' G: ' + GreenCS + ' R: ' + RedCS;
  end;
end;
{---------------------------------------------------------------------}

procedure TGRIPForm.MultiImage1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  dx: LongInt;
  dy: LongInt;
  Temp: Integer;
  dc: hdc;
  Colors: TColorRef;
  ImageHeighti: integer;
begin
{MouseLocatext      MouseRotatext}
  if (ViewMagniOn) then begin
  end else
  if (ViewCursorOn) then begin
    ViewCursorOnReally := False;
    DrawRubberband;
    ViewCursorOn := False;
    ViewX1 := pointStart.X;
    ViewX2 := pointEnd.X;
    ViewY1 := pointStart.Y;
    ViewY2 := pointEnd.Y;
     {Transfer the Points to the TEXT screen}
    ViewCursorScreen.Show;
     {With TViewCursorScreen.Create(Self) Do Show; }
  end else
  if Drawing then begin
      DrawRubberband;
      pointEnd.X := X;
      pointEnd.Y := Y;
      Drawing := False;
      StartDrawing := False; {Y is +- 9 from Horizontal...}
      if (((pointEnd.Y + 10) > pointStart.Y) and ((pointEnd.Y - 10) <
        pointStart.Y)) then
        PixelLine := ABS(pointStart.X - pointEnd.X)
      else begin
        dx := pointStart.x - pointEnd.x;
        dy := pointStart.y - pointEnd.y;
        PixelLine := Round(Sqrt((Dx * Dx) + (Dy * Dy)));
      end;
      Do_Measured;
  end else
  if ProfileDrawing then
  begin
        ProfileDrawing := False;
        LineProfileForm.DoImageMouseUp(X, Y);
  end else
  if (StartSnake) then begin {Linear Snake}
          StartSnake := False;
          ImageHeighti := ImageHeight;
          dc := GetDc(0);
          Colors := GetPixel(dc, X, ImageHeighti - Y);
    {dc := } ReleaseDc(0, dc);
          DoSnake(X, Y, Colors);
  end else
  if (ObjectLabeling) then begin {Object Labeling}
            ObjectLabeling := False;
            LabelObjectsForm.LOXEdit.Text := IntToStr(X);
            LabelObjectsForm.LOYEdit.Text := IntToStr(Y);
            LabelObjectsForm.PlaceLabel(X, Y);
  end else
  if ObjectMarkingOn then begin
              DrawRubberMark;
              pointEnd.X := X;
              pointEnd.Y := Y;
              ObjectMarkForm.LOX1Edit.Text := IntToStr(pointStart.x);
              ObjectMarkForm.LOY1Edit.Text := IntToStr(pointStart.y);
              ObjectMarkForm.LOX2Edit.Text := IntToStr(pointEnd.x);
              ObjectMarkForm.LOY2Edit.Text := IntToStr(pointEnd.y);
              ObjectMarkingOn := False;
              ObjectMarking := False;
              DrawRubberMark; {This PLACES it for KEEPS}
  end else
  if bTraining then begin
                DrawRubberband;
                pointEnd.X := X;
                pointEnd.Y := Y;
                bTraining := False;
                bStartTraining := False;
                if (pointEnd.Y > pointStart.Y) then begin
                  ViewY1 := pointStart.Y;
                  ViewY2 := pointEnd.Y;
                end else
                begin
                  ViewY2 := pointStart.Y;
                  ViewY1 := pointEnd.Y;
                end;
                if (pointEnd.X < pointStart.X) then begin
                  ViewX2 := pointStart.X;
                  ViewX1 := pointEnd.X;
                end else
                begin
                  ViewX1 := pointStart.X;
                  ViewX2 := pointEnd.X;
                end;
                ClassificationForm.CTrainingSites;
  end else
  if bLeftDown then begin
                  DrawRubberband;
                  bLeftDown := false;
                  pointEnd.X := X;
                  pointEnd.Y := Y;
  {The Lower Right is the START
  Upper left is the END}
                  if pointStart.X < pointEnd.X then
                  begin
                    Temp := pointStart.X;
                    pointStart.X := pointEnd.X;
                    pointEnd.X := Temp;
                  end;
                  if pointStart.Y < pointEnd.Y then
                  begin
                    Temp := pointStart.Y;
                    pointStart.Y := pointEnd.Y;
                    pointEnd.Y := Temp;
                  end;
  {Zoom , flip or rotate image}{Start,end will flip}
(*
  MultiImage1.TransformImage
 {  (Rect(pointStart.X, pointStart.Y, pointEnd.X, pointEnd.Y));}
    (Rect(pointEnd.X, pointEnd.Y,pointStart.X, pointStart.Y ));
*)
    Gauge1.Progress := 0;
  end;
end;
{---------------------------------------------------------------------}

procedure TGRIPForm.DrawRubberband;
begin
  SetROP2(Image1.Canvas.handle, R2_NOT);
  Image1.Canvas.moveto(pointStart.x, pointStart.y);
  Image1.Canvas.lineto(pointStart.x, pointEnd.y);
  Image1.Canvas.lineto(pointEnd.x, pointEnd.y);
  Image1.Canvas.lineto(pointEnd.x, pointStart.y);
  Image1.Canvas.lineto(pointStart.x, pointStart.y);
end;

procedure TGRIPForm.DrawRubberMark;
begin
  if ((ObjectMarkingOn) or (ObjectMarking)) then
    SetROP2(Image1.Canvas.handle, R2_NOT)
  else SetROP2(Image1.Canvas.handle, R2_COPYPEN);
{  Image1.Canvas.moveto(pointStart.x, pointStart.y);
  Image1.Canvas.lineto(pointStart.x, pointEnd.y);
  Image1.Canvas.lineto(pointEnd.x, pointEnd.y);
  Image1.Canvas.lineto(pointEnd.x, pointStart.y);
  Image1.Canvas.lineto(pointStart.x, pointStart.y);}
  with GRIPForm.Image1 do
  begin
    if ObjectMarkerArray[CurrentObjectMarker].ObjectType = 0 then
    begin
      Canvas.Pen.Color :=
        ObjectMarkerArray[CurrentObjectMarker].LineColor;
      Canvas.Brush.Color :=
        ObjectMarkerArray[CurrentObjectMarker].FillColor;
      if ObjectMarkerArray[CurrentObjectMarker].IsSolidFill then
        Canvas.Brush.Style := bsSolid
      else Canvas.Brush.Style := bsClear;
      Canvas.Pen.Color :=
        ObjectMarkerArray[CurrentObjectMarker].LineColor;
      Canvas.Ellipse(pointStart.x - 2,
        pointStart.y - 2,
        pointEnd.x + 2,
        pointEnd.y + 2);
    end else
      if ObjectMarkerArray[CurrentObjectMarker].ObjectType = 1 then
      begin
        Canvas.Pen.Color :=
          ObjectMarkerArray[CurrentObjectMarker].LineColor;
        Canvas.MoveTo(pointStart.x,
          pointStart.y);
        Canvas.LineTo(pointEnd.x,
          pointEnd.y);
      end else
        if ObjectMarkerArray[CurrentObjectMarker].ObjectType = 2 then
        begin
          Canvas.Brush.Color :=
            ObjectMarkerArray[CurrentObjectMarker].FillColor;
          if ObjectMarkerArray[CurrentObjectMarker].IsSolidFill then
            Canvas.Brush.Style := bsSolid
          else Canvas.Brush.Style := bsClear;
          Canvas.Pen.Color :=
            ObjectMarkerArray[CurrentObjectMarker].LineColor;
          Canvas.Ellipse(pointStart.x,
            pointStart.y,
            pointEnd.x,
            pointEnd.y);
        end else
          if ObjectMarkerArray[CurrentObjectMarker].ObjectType = 3
            then
          begin
            Canvas.Brush.Color :=
              ObjectMarkerArray[CurrentObjectMarker].FillColor;
            if ObjectMarkerArray[CurrentObjectMarker].IsSolidFill
              then
              Canvas.Brush.Style := bsSolid
            else Canvas.Brush.Style := bsClear;
            Canvas.Pen.Color :=
              ObjectMarkerArray[CurrentObjectMarker].LineColor;
            Canvas.Rectangle(pointStart.x,
              pointStart.y,
              pointEnd.x,
              pointEnd.y);
          end;
  end;
end;
(******************************************************)
(******************************************************)
(******************************************************)

procedure TGRIPForm.EO__OptionsClick(Sender: TObject);
begin
  OptionsForm := TOptionsForm.Create(Application);
  If OptionsForm.ShowModal = mrok then OptionsForm.Free
  else OptionsForm.Free;  {OptionsForm.Show;}
end;

(******************************************************)
(******************************************************)




{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure TGRIPForm.IZ_ZoomWindowClick(Sender: TObject);
begin
{Set up and call the image MagniForm: display area selector}
  if (IZ_ZoomWindow.Checked) then
  begin
      {Toggle OFF MagniForm}
    IZ_ZoomWindow.Checked := False;
    ViewMagniOn := False;
    MagniForm.Hide;
    Screen.Cursor := crDefault;
      {Erase the rubber band}
{      pointStart.X:=ViewX1;
      pointEnd.X:=ViewX2;
      pointStart.Y:=ViewY1;
      pointEnd.Y:=ViewY2;
      DrawRubberband;}
  end else begin
      {Actually Starts the MagniForm screen grabber}
    if Image1.Picture.Bitmap <> nil then begin
{      MagnifierSize := (64 div MagniForm.SpinEditMagnification.Value);}
      Screen.Cursor := crCross;
      MagniForm.Show;
      ViewMagniOn := True;
      IZ_ZoomWindow.Checked := True;
    end;
  end;
end;
(******************************************************)
(******************************************************)

procedure TGRIPForm.IV_PixelValuesUnClick;
begin
      {Toggle OFF}
  IV_PixelValues.Checked := False;
      {Erase the rubber band}
{      pointStart.X:=ViewX1;
      pointEnd.X:=ViewX2;
      pointStart.Y:=ViewY1;
      pointEnd.Y:=ViewY2;
      DrawRubberband; }
  ViewCursorOn := False;
  ViewCursorOnReally := FALSE;
  Screen.Cursor := crDefault;
end;

procedure TGRIPForm.IV_PixelValuesClick(Sender: TObject);
begin
{Grab a section of pixels and display as Text as RGB values}
  if (IV_PixelValues.Checked) then
  begin
    IV_PixelValuesUnClick;
  end else
  begin
      {Actually Starts the View screen grabber}
    if Image1.Picture.Bitmap <> nil then
    begin
      ViewCursorOn := True;
      IV_PixelValues.Checked := True;
    end;
  end;
end;

procedure TGRIPForm.IV_CMYScreenClick(Sender: TObject);
begin {Rotate through the CMY screens}
  DO_RGBNegRotate := (not DO_RGBNegRotate);
  if DO_RGBNegRotate then begin {set it up}
    IV_CMYScreen.Checked := DO_RGBNegRotate;
    Do_MakeBitmapRotate;
    if (MakeBitmapRotate) then begin
      Do_LoadedEnable(False);
      Do_KillMainMenu(False);
      IV_CMYScreen.Enabled := True;
      IV_CMYScreen.Checked := DO_RGBNegRotate;
      Do_TheRotate;
    end else begin {Clean it up}
      DoMessages(40000);
      Do_DeleteBitmapRotate;
      if (DeleteBitmapRotate <> TRUE) then DoMessages(40000);
      DO_RGBNegRotate := (not DO_RGBNegRotate);
      Do_LoadedEnable(True);
      Do_KillMainMenu(True);
      IV_CMYScreen.Checked := DO_RGBNegRotate;
    end;
  end else begin {shut it down}
    Do_DeleteBitmapRotate;
    if (DeleteBitmapRotate <> TRUE) then DoMessages(40000);
    MakeBitmapRotate := False;
    Do_LoadedEnable(True);
    Do_KillMainMenu(True);
    IV_CMYScreen.Checked := DO_RGBRotate;
  end;
end;

procedure TGRIPForm.IV_RGBScreenClick(Sender: TObject);
begin
{Rotate through the RGB screens}
  DO_RGBRotate := (not DO_RGBRotate);
  if DO_RGBRotate then begin {set it up}
    IV_RGBScreen.Checked := DO_RGBRotate;
    Do_MakeBitmapRotate;
    if (MakeBitmapRotate) then begin
      Do_LoadedEnable(False);
      Do_KillMainMenu(False);
      IV_RGBScreen.Enabled := True;
      IV_RGBScreen.Checked := DO_RGBRotate;
      Do_TheRotate;
    end else begin {Clean it up}
      DoMessages(40000);
      Do_DeleteBitmapRotate;
      if (DeleteBitmapRotate <> TRUE) then DoMessages(40000);
      DO_RGBRotate := (not DO_RGBRotate);
      Do_LoadedEnable(True);
      Do_KillMainMenu(True);
      IV_RGBScreen.Checked := DO_RGBRotate;
    end;
  end else begin {shut it down}
    Do_DeleteBitmapRotate;
    if (DeleteBitmapRotate <> TRUE) then DoMessages(40000);
    MakeBitmapRotate := False;
    Do_LoadedEnable(True);
    Do_KillMainMenu(True);
    IV_RGBScreen.Checked := DO_RGBRotate;
  end;
end;

procedure TGRIPForm.IV_onlyRedClick(Sender: TObject);
begin
  Do_Change(1); {}
end;

procedure TGRIPForm.IV_onlyGreenClick(Sender: TObject);
begin
  Do_Change(2); {}
end;

procedure TGRIPForm.IV_onlyBlueClick(Sender: TObject);
begin
  Do_Change(3); {}
end;
(******************************************************)
(******************************************************)
(******************************************************)
(******************************************************)

procedure TGRIPForm.I_UndoClick(Sender: TObject);
begin
  UndoImage;
  if LoggingToMacro then
  begin
    MacroForm.MacroRE.Lines.Add('=0001  UndoImage');
  end;
end;

procedure TGRIPForm.LogtoDIPClick(Sender: TObject);
begin
  if LogtoDIP.Checked then
  begin
    LogtoDIP.Checked := False;
    LoggingToDIP := False;
  end else
  begin
    LogtoDIP.Checked := True;
    LoggingToDIP := True;
  end;
end;
(******************************************************)
(******************************************************)

(******************************************************)
(******************************************************)

procedure TGRIPForm.F_ImageManagerClick(Sender: TObject);
begin {Always there}
  PBands.Show;
end;

procedure TGRIPForm.PreprocessPngs1Click(Sender: TObject);
begin
 { If (not REIVFormActive) then
  REIVForm := TREIVForm.Create(Application);
  REIVFormActive:=True;}
  REIVForm.Show;
end;

procedure TGRIPForm.I_SystemInfoClick(Sender: TObject);
begin {INFO}
  If (not SystemInfoFormActive) then
  SystemInfoForm := TSystemInfoForm.Create(Application);
  SystemInfoFormActive:=True;
  SystemInfoForm.Show;
end;

{This is used by Window.Imageinfo and File Loaders... maybe someday}
procedure TGRIPForm.PngInfo1Click(Sender: TObject);
var
  PNG: TPNGObject;
  i: Integer;
begin
  if Image1.Picture.Graphic is TPNGObject then
  begin
    If (not FrInfoActive) then
    FrInfo := TFrInfo.Create(Application);
    FrInfoActive:=True;
    FrInfo.Props.PageIndex := 0;
    {Set the chunk listbox}
    FrInfo.ChunkList.Items.Clear;
    {Copy pointer}
    PNG := TPNGObject(Image1.Picture.Graphic);
    if PNG.Chunks.Count > 0 then
      for i := 0 to PNG.Chunks.Count - 1 do
        with FrInfo.ChunkList.Items.Add do
        begin
          Caption := PNG.Chunks.item[I].Name;     {DataSize}
          subitems.Add(Format('%d bytes', [PNG.Chunks.item[i].DataSize]));
        end;
    FrInfo.ShowModal;
  end else DoMessages(25);
end;



procedure TGRIPForm.F_PrintClick(Sender: TObject);
begin
  if (PrinterSetupDialog1.Execute) then
  begin
    If (not PrintersizeFormActive) then
    PrintersizeForm := TPrintersizeForm.Create(Application);
    PrintersizeFormActive:=True;
    PrintersizeForm.ShowModal;
  end;
end;
(******************************************************)
(******************************************************)
procedure TGRIPForm.IH__HistogramClick(Sender: TObject);
begin
 { If (not HistogramFormActive) then
  HistogramForm := THistogramForm.Create(Application);
  HistogramFormActive:=True; }
  HistogramForm.Show;
end;

procedure TGRIPForm.IL__LinearClick(Sender: TObject);
begin
  {If (not LinearFormActive) then
  LinearForm := TLinearForm.Create(Application);
  LinearFormActive:=True;}
  LinearForm.Show;
end;

procedure TGRIPForm.IP__PixelAlgebraClick(Sender: TObject);
begin
  If (not PixelAlgebraFormActive) then
  PixelAlgebraForm := TPixelAlgebraForm.Create(Application);
  PixelAlgebraFormActive:=True;
  PixelAlgebraForm.Show;
end;

procedure TGRIPForm.IS__SpatialMatrixClick(Sender: TObject);
begin
  If (not FEditFormActive) then
  FEditForm := TFEditForm.Create(Application);
  FEditFormActive:=True;
  FEditForm.Show;
end;

procedure TGRIPForm.IF__FFTClick(Sender: TObject);
begin
  Showmessage('This is so bad, get IPTool'+#10#13+
  'http://www.ualg.pt/fct/adeec/vision/iptool/download.htm');
  {If (not FFTFormActive) then
  FFTForm := TFFTForm.Create(Application);
  FFTFormActive:=True;
  FFTForm.Show; }
end;

procedure TGRIPForm.IU__ClassificationClick(Sender: TObject);
begin
  If (not ClassificationFormActive) then
  ClassificationForm := TClassificationForm.Create(Application);
  ClassificationFormActive:=True;
  ClassificationForm.Show;
end;
(******************************************************)
(******************************************************)

procedure TGRIPForm.X_LabelObjectsClick(Sender: TObject);
begin   {Text annotation}
  If (not LabelObjectsFormActive) then
  LabelObjectsForm := TLabelObjectsForm.Create(Application);
  LabelObjectsFormActive:=True;
  LabelObjectsForm.Show;
end;

procedure TGRIPForm.X_ObjectorMMClick(Sender: TObject);
begin
  If (not ObjectMarkFormActive) then
  ObjectMarkForm := TObjectMarkForm.Create(Application);
  ObjectMarkFormActive:=True;
  ObjectMarkForm.Show;
end;

procedure TGRIPForm.X_MacroClick(Sender: TObject);
begin  {ALWAYS there}
  {MacroForm := TMacroForm.Create(Application);}
  MacroForm.Show;
end;


{If (not FileExists(RPM_DEM)) then PixelForm.Show;
With TPixelForm.Create(Self) do Show; }
{If (not FileExists(RPM_VDatabase)) then VoxelForm.Show;
With TVoxelForm.Create(Self) do Show;}
{If (not FileExists(RPM_Storage)) then MoxelForm.Show;
With TMoxelForm.Create(Self) do Show;}
{If (not FileExists(RPM_Vectors)) then VRLabForm.Show;
with TVRLabForm.Create(Self) DO Show;}

(******************************************************)
(******************************************************)
(******************************************************)
{
DIH  file name  Name of DIH
DIH X           Master data Width
DIH Y           Height
DIS file name     DIS subset image file name
X1= LC
X2= RC    Desired image starting positions:
Y1= TR
Y2= BR    Height and Width...
Number of Bands
1   Band File Names
2
3
4
5
6
7
Bands that become which RGB channels
Red: Band ?
Green: Band ?
Blue: Band ?
}

(******************************************************)
(******************************************************)
(******************************************************)









end.
