{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gPrOptions;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, ColorGrd, Buttons, ExtCtrls, ComCtrls;

type
  TOptionsForm = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ColorDialog1: TColorDialog;
    PageControl1: TPageControl;
    RasterOptions: TTabSheet;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    POM_ResetMenuBtn: TSpeedButton;
    Label32: TLabel;
    PO_ToggleRG: TRadioGroup;
    Colors: TTabSheet;
    Red: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    PO_ColorResetBtn: TSpeedButton;
    POSelectColorsBtn: TSpeedButton;
    PO_ColorPrintBtn: TSpeedButton;
    AcceptColorBtn: TSpeedButton;
    Label30: TLabel;
    CurrentColorBtn: TSpeedButton;
    DrawGrid1: TDrawGrid;
    ColorPanel: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    PO_TypeEdit: TEdit;
    POD_Edit: TEdit;
    ColorValuesPanel: TPanel;
    Directories: TTabSheet;
    POD_ImageDIRBtn: TSpeedButton;
    POD_DEMDIRBtn: TSpeedButton;
    POD_VectorDIRBtn: TSpeedButton;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    POD_VDatabaseDIRBtn: TSpeedButton;
    Label25: TLabel;
    POD_ResetDirectoriesBtn: TSpeedButton;
    POD_ProgramDIRBtn: TSpeedButton;
    Label49: TLabel;
    Label50: TLabel;
    POD_FilterDIRBtn: TSpeedButton;
    POD_StorageDIRBtn: TSpeedButton;
    Label51: TLabel;
    Label2: TLabel;
    POHelpBtn: TSpeedButton;
    VoicesCB: TCheckBox;
    BellsCB: TCheckBox;
    WhistlesCB: TCheckBox;
    ErrorNotUsedCB: TCheckBox;
    DoneNotificationCB: TCheckBox;
    TogglesRG: TRadioGroup;
    RealATMinEdit: TEdit;
    RealATMaxEdit: TEdit;
    IntATMinEdit: TEdit;
    IntATMaxEdit: TEdit;
    AbsoluteValuesCB: TCheckBox;
    SetAbsoluteValueCB: TCheckBox;
    SetAutorangeThresholdCB: TCheckBox;
    CurrentColorPanel: TPanel;
    RPM_ProgramEdit: TEdit;
    FilterPathEdit: TEdit;
    FilePathEdit: TEdit;
    RPM_DEMEdit: TEdit;
    RPM_VectorsEdit: TEdit;
    RPM_VDatabaseEdit: TEdit;
    RPM_StorageEdit: TEdit;
    Label1: TLabel;
    RPOClose: TBitBtn;
    RPOHelp: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenPreviewCB: TCheckBox;
    SavePreviewCB: TCheckBox;
    DisplayConvert32CB: TCheckBox;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    ErrorVoiceCB: TCheckBox;
    SpeedButton3: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormSet;
    procedure POM_ResetMenuBtnClick(Sender: TObject);
    procedure POHelpBtnClick(Sender: TObject);
    procedure POD_ResetDirectoriesBtnClick(Sender: TObject);
    procedure POD_ResetDirectories;
    procedure POD_ImageDIRBtnClick(Sender: TObject);
    procedure POD_DEMDIRBtnClick(Sender: TObject);
    procedure POD_VectorDIRBtnClick(Sender: TObject);
    procedure POD_VDatabaseDIRBtnClick(Sender: TObject);
    procedure POD_ProgramDIRBtnClick(Sender: TObject);
    procedure POD_FilterDIRBtnClick(Sender: TObject);
    procedure CurrentColorBtnClick(Sender: TObject);
    procedure POD_StorageDIRBtnClick(Sender: TObject);
    procedure VoicesCBClick(Sender: TObject);
    procedure BellsCBClick(Sender: TObject);
    procedure WhistlesCBClick(Sender: TObject);
    procedure ErrorNotUsedCBClick(Sender: TObject);
    procedure DoneNotificationCBClick(Sender: TObject);

    procedure POSelectColorsBtnClick(Sender: TObject);
    procedure PO_ColorResetBtnClick(Sender: TObject);
    procedure AcceptColorBtnClick(Sender: TObject);
    procedure DrawGrid1SelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure PO_ColorPrintBtnClick(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);

    procedure AbsoluteValuesCBClick(Sender: TObject);
    procedure SetAbsoluteValueCBClick(Sender: TObject);
    procedure PO_ToggleRGClick(Sender: TObject);
    procedure TogglesRGClick(Sender: TObject);
    procedure CurrentColorPanelClick(Sender: TObject);
    procedure RealATMinEditChange(Sender: TObject);
    procedure RealATMaxEditChange(Sender: TObject);
    procedure IntATMinEditChange(Sender: TObject);
    procedure IntATMaxEditChange(Sender: TObject);
    procedure RPOHelpClick(Sender: TObject);
    procedure SavePreviewCBClick(Sender: TObject);
    procedure OpenPreviewCBClick(Sender: TObject);
    procedure SetAutorangeThresholdCBClick(Sender: TObject);
    procedure MessageXEditChange(Sender: TObject);
    procedure MessageYEditChange(Sender: TObject);
    procedure ErrorVoiceCBClick(Sender: TObject);
    procedure RPOCloseClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure F_LoadColorDefaults;
    procedure SpareChange;
    procedure GettheColor;
  end;

var
  OptionsForm: TOptionsForm;

implementation

uses gGrip, gGlobal;

{$R *.DFM}
{------------------------------------------------------------------------}
var
  ColorChanging, ChangeRow, ChangeCol, ChangingColor: Longint;
{bIamDone,} foobar: Boolean;
{Bitmap: TBitmap;}
{------------------------------------------------------------------------}
procedure TOptionsForm.RPOHelpClick(Sender: TObject);
begin
  Application.HelpContext(3000);
end;
procedure TOptionsForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(3100);
end;
procedure TOptionsForm.SpeedButton2Click(Sender: TObject);
begin
  Application.HelpContext(3700);
end;
procedure TOptionsForm.SpeedButton1Click(Sender: TObject);
begin
  Application.HelpContext(3800);
end;


procedure TOptionsForm.RPOCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TOptionsForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  OptionsFormX := OptionsForm.left;
  OptionsFormY := OptionsForm.top;
  DoSaver;
end;

procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  left := OptionsFormX;
  top := OptionsFormY;
  FormSet;
end;

procedure TOptionsForm.FormShow(Sender: TObject);
var I, J: LongInt;
  Fooled: Boolean;
begin
  Fooled := True;
  for I := 0 to 8 do begin {Col}
    for J := 0 to 16 do begin {Row}
      DrawGrid1SelectCell(Sender, I, J, Fooled);
    end; end;
  FormSet; {FormSet last makes it do front page last
         ... so it is now on top}
end;

procedure TOptionsForm.FormSet;
var tempStr: string;
begin
  RPM_ProgramEdit.text := RPM_Program;
  FilterPathEdit.text := FilterPath;
  FilePathEdit.text := ImagePath;
  RPM_DEMEdit.text := RPM_DEM;
  RPM_VectorsEdit.text := RPM_Vectors;
  RPM_VDatabaseEdit.text := RPM_VDatabase;
  RPM_StorageEdit.text := RPM_Storage;

  OpenPreviewCB.Checked := OpenWithPreview;
  SavePreviewCB.Checked := SaveWithPreview;
  DisplayConvert32CB.Checked := DisplayConvert32;
{FileAutoDisplayCB.Checked:=AutoDisPlay;}
  DoneNotificationCB.Checked := DoneBeepOn;
  ErrorNotUsedCB.Checked := ErrorBeepOn;
  ErrorVoiceCB.Checked := ErrorVoiceOn;
  WhistlesCB.Checked := WhistlesOn;
  BellsCB.Checked := BellsOn;
  VoicesCB.Checked := VoicesOn;
  CurrentColorPanel.Color := CurrentColor;
  AbsoluteValuesCB.Checked := V_Absolute;
  SetAbsoluteValueCB.Checked := R_AutoTT;
  SetAutorangeThresholdCB.Checked := S_Threshold;
  str(dAT_Min: 5: 1, tempStr); RealATMinEdit.Text := tempStr;
  str(dAT_Max: 5: 1, tempStr); RealATMaxEdit.Text := tempStr;
  str(bST_Min, tempStr); IntATMinEdit.Text := tempStr;
  str(bST_Max, tempStr); IntATMaxEdit.Text := tempStr;

  if Toggle_D_RGB = True then PO_ToggleRG.ItemIndex := 3;
  if ((Toggle_D_RGB = True) and (Toggle_D_R = True)) then
    Toggle_D_RGB := False;
  if Toggle_D_R = True then PO_ToggleRG.ItemIndex := 2;
  if ((Toggle_D_G = True) and (Toggle_D_R = True)) then
    Toggle_D_R := False;
  if Toggle_D_G = True then PO_ToggleRG.ItemIndex := 1;
  if ((Toggle_D_G = True) and (Toggle_D_B = True)) then
    Toggle_D_G := False;
  if Toggle_D_B = True then PO_ToggleRG.ItemIndex := 0;

  if (Do_Ex_com = True) then TogglesRG.ItemIndex := 1 else
    if (BelowZero = True) then TogglesRG.ItemIndex := 2 else
      if (AutoRange = True) then TogglesRG.ItemIndex := 3 else
      begin ClipR := True; TogglesRG.ItemIndex := 0; end;
  MessageYEdit.TExt := IntToStr(MessageY);
  MessageXEdit.TExt := IntToStr(MessageX);
end;
{------------------------------------------------------------------------}

procedure TOptionsForm.SpeedButton3Click(Sender: TObject);
begin
  DoMessages(9999);
end;

procedure TOptionsForm.MessageXEditChange(Sender: TObject);
begin
  MessageX := StrToInt(MessageXEdit.Text);
end;

procedure TOptionsForm.MessageYEditChange(Sender: TObject);
begin
  MessageY := StrToInt(MessageYEdit.Text);
end;

procedure TOptionsForm.POM_ResetMenuBtnClick(Sender: TObject);
begin {load Menu defaults}
  OpenWithPreview := True;
  SaveWithPreview := True;
  DisplayConvert32 := True;
  CurrentColor := clBlack;
  VoicesON := False;
  DoneBeepOn := False;
  ErrorBeepOn := False;
  ErrorVoiceOn := False;
  MessageY := (123);
  MessageX := (123);
  R_AutoTT := False;
  V_Absolute := False;
  dAT_Min := 0;
  dAT_Max := 255;
  AUTORANGE := False;
  S_Threshold := False;
  bST_Max := 255;
  bST_Min := 0;
  ClipR := True;
  Do_Ex_Com := False;
  BelowZero := False;
  Toggle_D_RGB := FALSE;
  Toggle_D_R := FALSE;
  Toggle_D_G := FALSE;
  Toggle_D_B := True;
  FormSet;
end;
(********************************************************************)
(********************************************************************)


(********************************************************************)
(********************************************************************)
(********************************************************************)


(********************************************************************)
(********************************************************************)

procedure TOptionsForm.POD_ResetDirectoriesBtnClick(Sender: TObject);
begin
  POD_ResetDirectories;
end;

procedure TOptionsForm.POD_ResetDirectories;
begin
{Reset Directories defaults  }
  RPM_Program := ExtractFilePath(ParamStr(0));
  FilterPath := {ExpandFileName}(RPM_Program + '\Filters\');
  ImagePath := {ExpandFileName}(RPM_Program { +'Images\'});
  RPM_DEM := {ExpandFileName}(RPM_Program {+'DEM\'});
  RPM_Vectors := {ExpandFileName}(RPM_Program {+'Vectors\'});
  RPM_VDatabase := {ExpandFileName}(RPM_Program {+'V_Database\'});
  RPM_Storage := {ExpandFileName}(RPM_Program { +'Storage\'});
  RPM_ProgramEdit.text := RPM_Program;
  FilterPathEdit.text := FilterPath;
  FilePathEdit.text := ImagePath;
  RPM_DEMEdit.text := RPM_DEM;
  RPM_VectorsEdit.text := RPM_Vectors;
  RPM_VDatabaseEdit.text := RPM_VDatabase;
  RPM_StorageEdit.text := RPM_Storage;
end;
(********************************************************************)

procedure TOptionsForm.POD_ProgramDIRBtnClick(Sender: TObject);
begin
{Load file.. get Program Directory}
  OpenDialog1.Filter := 'Raster Program|Raster.EXE';
  OpenDialog1.FileName := 'Raster.EXE';
  OpenDialog1.InitialDir := RPM_Program;
  if OpenDialog1.execute then
    RPM_Program := ExtractFilePath(OpenDialog1.filename);
  RPM_ProgramEdit.text := RPM_Program;
end;

procedure TOptionsForm.POD_FilterDIRBtnClick(Sender: TObject);
begin
{Load file.. get Program Directory}
  OpenDialog1.Filter := 'Filters.R?|*.R*';
  OpenDialog1.InitialDir := FilterPath;
  OpenDialog1.FileName := '*.R*';
  if OpenDialog1.execute then
    FilterPath := ExtractFilePath(OpenDialog1.filename);
  FilterPathEdit.text := FilterPath;
end;

procedure TOptionsForm.POD_ImageDIRBtnClick(Sender: TObject);
begin
{Load file.. get Image Directory}
  OpenDialog1.Filter := 'Images.RIH|*.RIH;*.PNG;*.*';
  OpenDialog1.InitialDir := ImagePath;
  OpenDialog1.FileName := '*.*';
  if OpenDialog1.execute then
    ImagePath := ExtractFilePath(OpenDialog1.filename);
  FilePathEdit.text := ImagePath;
end;

procedure TOptionsForm.POD_DEMDIRBtnClick(Sender: TObject);
begin
{Get Raster manipulator Directory}
  OpenDialog1.Filter := 'your Image Editor *.exe |*.exe';
  OpenDialog1.InitialDir := RPM_DEM;
  OpenDialog1.FileName := '*.*';
  if OpenDialog1.execute then
    RPM_DEM := {ExtractFilePath}(OpenDialog1.filename);
  RPM_DEMEdit.text := RPM_DEM;
end;

procedure TOptionsForm.POD_VectorDIRBtnClick(Sender: TObject);
begin
{Get Vector Directory}
  OpenDialog1.Filter := 'Vector creator *.exe |*.exe;';
  OpenDialog1.InitialDir := RPM_Vectors;
  OpenDialog1.FileName := '*.exe';
  if OpenDialog1.execute then
    RPM_Vectors := {ExtractFilePath}(OpenDialog1.filename);
  RPM_VectorsEdit.text := RPM_Vectors;
end;

procedure TOptionsForm.POD_VDatabaseDIRBtnClick(Sender: TObject);
begin
{Get Vector database Directory}
  OpenDialog1.Filter := 'your special effects *.exe |*.exe';
  OpenDialog1.InitialDir := RPM_VDatabase;
  OpenDialog1.FileName := '*.exe';
  if OpenDialog1.execute then
    RPM_VDatabase := {ExtractFilePath}(OpenDialog1.filename);
  RPM_VDatabaseEdit.text := RPM_VDatabase;
end;

procedure TOptionsForm.POD_StorageDIRBtnClick(Sender: TObject);
begin
{Get Storage database Directory}
  OpenDialog1.Filter := 'your movie maker *.exe |*.exe';
  OpenDialog1.InitialDir := RPM_Storage;
  OpenDialog1.FileName := '*.exe';
  if OpenDialog1.execute then
    RPM_Storage := {ExtractFilePath}(OpenDialog1.filename);
  RPM_StorageEdit.text := RPM_Storage;
end;
(********************************************************************)

(********************************************************************)
(********************************************************************)

procedure TOptionsForm.PO_ColorResetBtnClick(Sender: TObject);
begin
  F_LoadColorDefaults;
end;

procedure TOptionsForm.F_LoadColorDefaults;
begin
(*
CONST
 { ##   =hex= ##
 255=FF       FF=255 FE=254
 240=F0       EF=239
 224=E0       DF=223
 208=D0       CF=207
 192=C0       BF=191
 176=B0       AF=175
 160=A0       9F=159
 144=90       8F=143
 128=80       7F=127
 112=70       6F=111
  96=60       5F=95
  80=50       4F=79
  64=40       3F=63
  48=30       2F=47
  32=20       1F=31
  16=10        F=15     B G R
   1=1         0=0   2B2G2R      RGB}*)
  ColorBlack := $00000000;
  ColorWhite := $00FFFFFF; {255,255,255} {White}
  ColorYELLOW := $0000BFBF; {YELLOW 191,191,0}
  ColorPURPLE := $00FE00FE; {254,0,254}
  ColorLYELLOW := $0000FEFE; {255,255,0}
  ColorDPURPLE := $007F007F; {128,0,128}
  Color1 := $00BF0000;
  Color2 := $00BFBF00;
  Color3 := $0000BF00;
  Color4 := $009F9FBF;
  Color5 := $00007FBF;
  Color6 := $009FBF9F;
  Color7 := $00BFAFBF;
  Color8 := $000000BF;
  Color9 := $00BFBFBF; {191,191,191: LIGHT GRAY [!]}
  CurrentColor := clBlack;
  UVW := $000F0000;
  VDW := $001F0000;
  VMW := $002F0000;
  VLW := $003F0000;
  UDW := $004F0000;
 {UUDBlueWater} UMW := $005F0000; {0,0,95} {ULTRA Dark Blue}
  ULW := $006F0000;
 {DkDBlueWater} DDW := $007F0000; {0,0,127} {Dark D Blue[!]}
 {DkMBlueWater} DMW := $008F0000; {0,0,143} {Dark M Blue[!]}
  DLW := $009F0000;
 {MDkBlueWater} MDW := $00AF0000; {0,0,175} {M Dark Blue[!]}
 {MdMBlueWater} MMW := $00BF0000; {0,0,191} {MEDIUM M Blue}
  MLW := $00CF0000;
  LDW := $00DF0000; {LtMBlueWater}
  LMW := $00EF0000; {0,0,239} {Light M Blue[!]}
  LLW := $00FE0000; {0,0,254} {LIGHT L Blue[!]}
  UVC := $000F0F00;
  VDC := $001F1F00;
  VMC := $002F2F00;
  VLC := $003F3F00;
  UDC := $004F4F00;
  UMC := $005F5F00;
  ULC := $006F6F00;
  DDC := $007F7F00; {0,143,143} {DARK M CYAN[!]}
  DMC := $008F8F00; {DkMBlueWetland}
  DLC := $009F9F00; {MdMBlueWetland}
  MDC := $00AFAF00; {0,191,191} {MEDIUM M CYAN}
  MMC := $00BFBF00;
  MLC := $00CFCF00;
 {LtMBlueWetland} LDC := $00DFDF00; {0,239,239} {LIGHT M CYAN[!]}
  LMC := $00EFEF00;
  LLC := $00FEFE00;

  UVF := $00000F00;
  VDF := $00001F00;
  VMF := $00002F00;
  VLF := $00003F00;
 {UDDGreenForest} UDF := $00004F00; {0,111,0}
  UMF := $00005F00;
  ULF := $00006F00;
 {DkMGreenForest} DDF := $00007F00; {0,143,0}
  DMF := $00008F00;
  DLF := $00009F00;
 {MdDGreenForest} MDF := $0000AF00; {0,175,0} {DARK GREEN [!]}
 {MdMGreenForest} MMF := $0000BF00; {0,191,0} {MEDIUM GREEN}
 {MdLGreenForest} MLF := $0000CF00; {0,207,0} {LIGHT GREEN[!]}
  LDF := $0000DF00;
 {LtMGreenForest} LMF := $0000EF00; {0,239,0}
 {LtMGreenForest} LLF := $0000FE00; {0,254,0}

  UVA := $0001010F;
  VDA := $0005051F;
  VMA := $000F0F2F;
  VLA := $001F1F3F;
  UDA := $002F2F4F;
 {UUAgricultural} UMA := $003F3F5F; {95,63,63} {UU BROWN}
 {UDAgricultural} ULA := $004F4F6F; {111,79,79} {UD BROWN}
 {UDAgricultural} DDA := $005F5F7F; {127,95,95} { BROWN}
 {DDAgricultural} DMA := $006F6F8F; {143,111,111} {BROWN }
 {DKAgricultural} DLA := $007F7F9F; {159,127,127} {BROWN }
 {DMAgricultural} MDA := $008F8FAF; {175,143,143} {BROWN }
 {MdAgricultural} MMA := $009F9FBF; {191,159,159} {BROWN }
 {LMAgricultural} MLA := $00AFAFCF; {207,175,175} {BROWN }
 {LtAgricultural} LDA := $00BFBFDF; {223,191,191} {BROWN }
 {LLAgricultural} LMA := $00CFCFEF; {239,207,207} {BROWN }
 {ULAgricultural} LLA := $00DFDFFE; {254,223,223} {BROWN }

  UVR := $0000030F;
  VDR := $0000071F;
  VMR := $0000102F;
  VLR := $0000133F;
  UDR := $00000F4F;
  UMR := $00001F5F;
  ULR := $00002F6F;
 {DkMRangeland} DDR := $00003F7F; {143,79,0} {DARK M ORANGE}
  DMR := $00004F8F;
  DLR := $00005F9F;
 {MdMRangeland} MDR := $00006FAF; {191,127,0} {MEDIUM M ORANGE}
  MMR := $00007FBF;
  MLR := $00008FCF;
 {LtMRangeland} LDR := $00009FDF; {239,175,0} {LIGHT M ORANGE}
  LMR := $0000AFEF;
  LLR := $0000BFFE;

  UVT := $00060F06;
  VDT := $00121F12;
  VMT := $000F2F0F;
  VLT := $001F3F1F;
  UDT := $002F4F2F;
  UMT := $003F5F3F;
  ULT := $004F6F4F;
 {DkMGrayTundra} DDT := $005F7F5F; {111,143,111} {dark M Ggray}
  DMT := $006F8F6F;
  DLT := $007F9F7F;
 {MdMGrayTundra} MDT := $008FAF8F; {159,191,159} {medium M Ggray}
  MMT := $009FBF9F;
  MLT := $00AFCFAF;
 {LtMGrayTundra} LDT := $00BFDFBF; {207,239,207} {light M Ggray}
  LMT := $00CFEFCF;
  LLT := $00DFFEDF; {223,254,223}

  UVB := $000F060F;
  VDB := $001F0F1F;
  VMB := $002F1F2F;
  VLB := $003F2F3F;
  UDB := $004F3F4F;
  UMB := $005F4F5F;
  ULB := $006F5F6F;
 {DkMBarren} DDB := $007F6F7F; {143,127,143} {DARK M P_GRAY}
  DMB := $008F7F8F;
  DLB := $009F8F9F;
 {MdMBarren} MDB := $00AF9FAF; {191,175,191} {MEDIUM M P_GRAY}
  MMB := $00BFAFBF;
  MLB := $00CFBFCF;
 {LtMBarren} LDB := $00DFCFDF; {239,223,239} {LIGHT M P_GRAY}
  LMB := $00EFDFEF;
  LLB := $00FEEFFE; {254,239,254}

  UVU := $0000000F;
  VDU := $0000001F;
  VMU := $0000002F;
  VLU := $0000003F;
  UDU := $0000004F;
  UMU := $0000005F;
 {UDkRedUrban} ULU := $0000006F; {95,0,0} {DARK U RED[!]}
 {DDkRedUrban} DDU := $0000007F; {127,0,0} {DARK D RED[!]}
 {DkMRedUrban} DMU := $0000008F; {143,0,0} {DARK M RED[!]}
 {DkLRedUrban} DLU := $0000009F; {159,0,0} {DARK L RED[!]}
 {MdMRedUrban} MDU := $000000AF; {191,0,0} {MEDIUM M RED}
  MMU := $000000BF;
  MLU := $000000CF;
 {LtDRedUrban} LDU := $000000DF; {223,0,0} {LIGHT D RED[!]}
 {LtMRedUrban} LMU := $000000EF; {239,0,0} {LIGHT M RED[!]}
 {LLtRedUrban} LLU := $000000FE; {254,0,0} {LIGHT L RED[!]}

  UVS := $000F0F0F;
  VDS := $001F1F1F;
  VMS := $002F2F2F;
  VLS := $003F3F3F;
  UDS := $004F4F4F;
  UMS := $005F5F5F;
  ULS := $006F6F6F;
 {DkMWhiteSnow} DDS := $007F7F7F; {143,143,143} {Dark M white}
  DMS := $008F8F8F;
  DLS := $009F9F9F;
 {MdMWhiteSnow} MDS := $00AFAFAF; {191,191,191} {medium M white}
  MMS := $00BFBFBF;
  MLS := $00CFCFCF;
  LDS := $00DFDFDF;
 {LtMWhiteSnow} LMS := $00EFEFEF; {239,239,239} {off M white}
 {ULtWhiteSnow} LLS := $00FEFEFE; {254,254,254} {off M white}
 {Snow or Ice? Black or White is NOT Classified items?}
end;
{------------------------------------------------------------------------}

{------------------------------------------------------------------------}


{------------------------------------------------------------------------}

{------------------------------------------------------------------------}

{------------------------------------------------------------------------}

procedure TOptionsForm.DrawGrid1DrawCell(Sender: TObject; Col,
  Row: Longint; Rect: TRect; State: TGridDrawState);
begin
  case Col of
    0: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color1;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVW;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 1}
    1: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color2;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVC;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 2}
    2: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color3;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVF;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 3}
    3: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color4;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVA;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 4}
    4: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color5;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVR;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 5}
    5: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color6;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVT;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 6}
    6: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color7;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVB;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 7}
    7: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color8;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVU;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 8}
    8: begin
        case Row of
          0: begin
              DrawGrid1.Canvas.Brush.Color := Color9;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          1: begin
              DrawGrid1.Canvas.Brush.Color := LLS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          2: begin
              DrawGrid1.Canvas.Brush.Color := LMS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          3: begin
              DrawGrid1.Canvas.Brush.Color := LDS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          4: begin
              DrawGrid1.Canvas.Brush.Color := MLS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          5: begin
              DrawGrid1.Canvas.Brush.Color := MMS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          6: begin
              DrawGrid1.Canvas.Brush.Color := MDS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          7: begin
              DrawGrid1.Canvas.Brush.Color := DLS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          8: begin
              DrawGrid1.Canvas.Brush.Color := DMS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          9: begin
              DrawGrid1.Canvas.Brush.Color := DDS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          10: begin
              DrawGrid1.Canvas.Brush.Color := ULS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          11: begin
              DrawGrid1.Canvas.Brush.Color := UMS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          12: begin
              DrawGrid1.Canvas.Brush.Color := UDS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          13: begin
              DrawGrid1.Canvas.Brush.Color := VLS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          14: begin
              DrawGrid1.Canvas.Brush.Color := VMS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          15: begin
              DrawGrid1.Canvas.Brush.Color := VDS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
          16: begin
              DrawGrid1.Canvas.Brush.Color := UVS;
              DrawGrid1.Canvas.FillRect(Rect);
            end;
        end; end; {Case 9}
  end; {Case} end; {PROCEDURE}
{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

procedure TOptionsForm.DrawGrid1SelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
{var RString,GString,BString:String;}
begin
{Select the Cell, Place Color values in The Edits
When whatever Acceept Color Button is pressed
then change the Color of THIS CELL
DrawGrid1.Cells[Col,Row]=}
  CanSelect := True; foobar := false;
  ChangeRow := Row; ChangeCol := Col;
  SpareChange;
end;
{------------------------------------------------------------------------}

procedure TOptionsForm.AcceptColorBtnClick(Sender: TObject);
begin
  if (not (ColorPanel.Color = clBtnFace)) then begin
    ColorChanging := ColorPanel.Color;
    foobar := true;
    GettheColor;
    foobar := False;
  end;
end;

procedure TOptionsForm.CurrentColorBtnClick(Sender: TObject);
begin
  if (not (ColorPanel.Color = clBtnFace)) then begin
    CurrentColor := ColorPanel.Color;
    CurrentColorPanel.Color := ColorPanel.Color;
  end;
end;
{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

procedure TOptionsForm.POSelectColorsBtnClick(Sender: TObject);
var RString, GString, BString: string;
begin foobar := false;
  if ColorDialog1.Execute then begin
    ColorPanel.Color := ColorDialog1.Color;
    Str(GetRValue(ColorPanel.Color), RString);
    Str(GetGValue(ColorPanel.Color), GString);
    Str(GetBValue(ColorPanel.Color), BString);
    ColorValuesPanel.Caption := 'B:' + BString + ' G:' + GString +
      ' R:' + RString;
  end;
end;

{------------------------------------------------------------------------}
{------------------------------------------------------------------------}

procedure TOptionsForm.PO_ColorPrintBtnClick(Sender: TObject);
begin
{Print out the Color Swatch}
{Call The Histogram blank and plot the color to it then print it}
end;

procedure TOptionsForm.SpareChange;
var RString, GString, BString: string;
begin
  GettheColor;
  Str(GetRValue(ChangingColor), RString); Edit1.Text := RString;
  Str(GetGValue(ChangingColor), GString); Edit2.Text := GString;
  Str(GetBValue(ChangingColor), BString); Edit3.Text := BString;
  Application.ProcessMessages;
end;

procedure TOptionsForm.GettheColor;
begin
  case ChangeCol of
    0: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color1;
              if foobar then Color1 := ColorChanging;
              PO_TypeEdit.Text := 'Color1 ';
              POD_Edit.Text := 'Water';
            end;
          1: begin
              ChangingColor := LLW;
              if foobar then LLW := ColorChanging;
              PO_TypeEdit.Text := 'LLW :90';
              POD_Edit.Text := 'Rocky Wetland';
            end;
          2: begin
              ChangingColor := LMW;
              if foobar then LMW := ColorChanging;
              PO_TypeEdit.Text := 'LMW: 80';
              POD_Edit.Text := 'Riverine: Intermittent';
            end;
          3: begin
              ChangingColor := LDW;
              if foobar then LDW := ColorChanging;
              PO_TypeEdit.Text := 'LDW: 70';
              POD_Edit.Text := 'Riverine: Upper Perennial';
            end;
          4: begin
              ChangingColor := MLW;
              if foobar then MLW := ColorChanging;
              PO_TypeEdit.Text := 'MLW: 60';
              POD_Edit.Text := 'Riverine Braided';
            end;
          5: begin
              ChangingColor := MMW;
              if foobar then MMW := ColorChanging;
              PO_TypeEdit.Text := 'MMW: 50';
              POD_Edit.Text := 'Riverine: Lower Perennial';
            end;
          6: begin
              ChangingColor := MDW;
              if foobar then MDW := ColorChanging;
              PO_TypeEdit.Text := 'MDW: 40';
              POD_Edit.Text := 'Riverine: Tidal';
            end;
          7: begin
              ChangingColor := DLW;
              if foobar then DLW := ColorChanging;
              PO_TypeEdit.Text := 'DLW 30';
              POD_Edit.Text := 'Lacustrine: Limnetic';
            end;
          8: begin
              ChangingColor := DMW;
              if foobar then DMW := ColorChanging;
              PO_TypeEdit.Text := 'DMW 20';
              POD_Edit.Text := 'Estuary: Subtidal';
            end;
          9: begin
              ChangingColor := DDW;
              if foobar then DDW := ColorChanging;
              PO_TypeEdit.Text := 'DDW 10';
              POD_Edit.Text := 'Marine: Subtidal';
            end;
          10: begin
              ChangingColor := ULW;
              if foobar then ULW := ColorChanging;
              PO_TypeEdit.Text := 'ULW: 009';
              POD_Edit.Text := 'Water';
            end;
          11: begin
              ChangingColor := UMW;
              if foobar then UMW := ColorChanging;
              PO_TypeEdit.Text := 'UMW: 008';
              POD_Edit.Text := 'Water';
            end;
          12: begin
              ChangingColor := UDW;
              if foobar then UDW := ColorChanging;
              PO_TypeEdit.Text := 'UDW: 007';
              POD_Edit.Text := 'Water';
            end;
          13: begin
              ChangingColor := VLW;
              if foobar then VLW := ColorChanging;
              PO_TypeEdit.Text := 'VLW: 006';
              POD_Edit.Text := 'Water';
            end;
          14: begin
              ChangingColor := VMW;
              if foobar then VMW := ColorChanging;
              PO_TypeEdit.Text := 'VMW: 005';
              POD_Edit.Text := 'Water';
            end;
          15: begin
              ChangingColor := VDW;
              if foobar then VDW := ColorChanging;
              PO_TypeEdit.Text := 'VDW: 004';
              POD_Edit.Text := 'Water';
            end;
          16: begin
              ChangingColor := UVW;
              if foobar then UVW := ColorChanging;
              PO_TypeEdit.Text := 'UVW: 003';
              POD_Edit.Text := 'Water';
            end;
        end; end; {Case 1}
    1: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color2;
              if foobar then Color2 := ColorChanging;
              PO_TypeEdit.Text := 'Color2';
              POD_Edit.Text := 'Wetland';
            end;
          1: begin
              ChangingColor := LLC;
              if foobar then LLC := ColorChanging;
              PO_TypeEdit.Text := 'LLC: 90';
              POD_Edit.Text := 'Unconsolidated: Mud';
            end;
          2: begin
              ChangingColor := LMC;
              if foobar then LMC := ColorChanging;
              PO_TypeEdit.Text := 'LMC: 80';
              POD_Edit.Text := 'Moss-Lichen Wetland';
            end;
          3: begin
              ChangingColor := LDC;
              if foobar then LDC := ColorChanging;
              PO_TypeEdit.Text := 'LDC: 70';
              POD_Edit.Text := 'Scrub-Shrub Wetland';
            end;
          4: begin
              ChangingColor := MLC;
              if foobar then MLC := ColorChanging;
              PO_TypeEdit.Text := 'MLC: 60';
              POD_Edit.Text := 'Forested Wetland';
            end;
          5: begin
              ChangingColor := MMC;
              if foobar then MMC := ColorChanging;
              PO_TypeEdit.Text := 'MMC: 50';
              POD_Edit.Text := 'Emergent Wetland';
            end;
          6: begin
              ChangingColor := MDC;
              if foobar then MDC := ColorChanging;
              PO_TypeEdit.Text := 'MDC: 40';
              POD_Edit.Text := 'Aquatic Bed Wetland';
            end;
          7: begin
              ChangingColor := DLC;
              if foobar then DLC := ColorChanging;
              PO_TypeEdit.Text := 'DLC: 30';
              POD_Edit.Text := 'Lacustrine: Littoral';
            end;
          8: begin
              ChangingColor := DMC;
              if foobar then DMC := ColorChanging;
              PO_TypeEdit.Text := 'DMC: 20';
              POD_Edit.Text := 'Estuary: Intertidal';
            end;
          9: begin
              ChangingColor := DDC;
              if foobar then DDC := ColorChanging;
              PO_TypeEdit.Text := 'DDC: 10';
              POD_Edit.Text := 'Marine: Intertidal';
            end;
          10: begin
              ChangingColor := ULC;
              if foobar then ULC := ColorChanging;
              PO_TypeEdit.Text := 'ULC: 009';
              POD_Edit.Text := 'Wetland';
            end;
          11: begin
              ChangingColor := UMC;
              if foobar then UMC := ColorChanging;
              PO_TypeEdit.Text := 'UMC: 008';
              POD_Edit.Text := 'Wetland';
            end;
          12: begin
              ChangingColor := UDC;
              if foobar then UDC := ColorChanging;
              PO_TypeEdit.Text := 'UDC: 007';
              POD_Edit.Text := 'Wetland';
            end;
          13: begin
              ChangingColor := VLC;
              if foobar then VLC := ColorChanging;
              PO_TypeEdit.Text := 'VLC: 006';
              POD_Edit.Text := 'Wetland';
            end;
          14: begin
              ChangingColor := VMC;
              if foobar then VMC := ColorChanging;
              PO_TypeEdit.Text := 'VMC: 005';
              POD_Edit.Text := 'Wetland';
            end;
          15: begin
              ChangingColor := VDC;
              if foobar then VDC := ColorChanging;
              PO_TypeEdit.Text := 'VDC: 004';
              POD_Edit.Text := 'Wetland';
            end;
          16: begin
              ChangingColor := UVC;
              if foobar then UVC := ColorChanging;
              PO_TypeEdit.Text := 'UVC: 003';
              POD_Edit.Text := 'Wetland';
            end;
        end; end; {Case 2}
    2: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color3;
              if foobar then Color3 := ColorChanging;
              PO_TypeEdit.Text := 'Color3';
              POD_Edit.Text := 'Forest';
            end;
          1: begin
              ChangingColor := LLF;
              if foobar then LLF := ColorChanging;
              PO_TypeEdit.Text := 'LLF: 90';
              POD_Edit.Text := 'Forest: Cut';
            end;
          2: begin
              ChangingColor := LMF;
              if foobar then LMF := ColorChanging;
              PO_TypeEdit.Text := 'LMF: 80';
              POD_Edit.Text := 'Forest: Burnt';
            end;
          3: begin
              ChangingColor := LDF;
              if foobar then LDF := ColorChanging;
              PO_TypeEdit.Text := 'LDF: 70';
              POD_Edit.Text := 'Krumholz Zone/Edge';
            end;
          4: begin
              ChangingColor := MLF;
              if foobar then MLF := ColorChanging;
              PO_TypeEdit.Text := 'MLF: 60';
              POD_Edit.Text := 'Scrub Forest';
            end;
          5: begin
              ChangingColor := MMF;
              if foobar then MMF := ColorChanging;
              PO_TypeEdit.Text := 'MMF: 50';
              POD_Edit.Text := 'Broadleaf Deciduous';
            end;
          6: begin
              ChangingColor := MDF;
              if foobar then MDF := ColorChanging;
              PO_TypeEdit.Text := 'MDF: 40';
              POD_Edit.Text := 'Broadleaf Evergreen';
            end;
          7: begin
              ChangingColor := DLF;
              if foobar then DLF := ColorChanging;
              PO_TypeEdit.Text := 'DLF: 30';
              POD_Edit.Text := 'Needle Deciduous';
            end;
          8: begin
              ChangingColor := DMF;
              if foobar then DMF := ColorChanging;
              PO_TypeEdit.Text := 'DMF: 20';
              POD_Edit.Text := 'Needle Evergreen';
            end;
          9: begin
              ChangingColor := DDF;
              if foobar then DDF := ColorChanging;
              PO_TypeEdit.Text := 'DDF: 10';
              POD_Edit.Text := 'Tropical Forest: Jungle';
            end;
          10: begin
              ChangingColor := ULF;
              if foobar then ULF := ColorChanging;
              PO_TypeEdit.Text := 'ULF: 009';
              POD_Edit.Text := 'Forest';
            end;
          11: begin
              ChangingColor := UMF;
              if foobar then UMF := ColorChanging;
              PO_TypeEdit.Text := 'UMF: 008';
              POD_Edit.Text := 'Forest';
            end;
          12: begin
              ChangingColor := UDF;
              if foobar then UDF := ColorChanging;
              PO_TypeEdit.Text := 'UDF: 007';
              POD_Edit.Text := 'Forest';
            end;
          13: begin
              ChangingColor := VLF;
              if foobar then VLF := ColorChanging;
              PO_TypeEdit.Text := 'VLF: 006';
              POD_Edit.Text := 'Forest';
            end;
          14: begin
              ChangingColor := VMF;
              if foobar then VMF := ColorChanging;
              PO_TypeEdit.Text := 'VMF: 005';
              POD_Edit.Text := 'Forest';
            end;
          15: begin
              ChangingColor := VDF;
              if foobar then VDF := ColorChanging;
              PO_TypeEdit.Text := 'VDF: 004';
              POD_Edit.Text := 'Forest';
            end;
          16: begin
              ChangingColor := UVF;
              if foobar then UVF := ColorChanging;
              PO_TypeEdit.Text := 'UVF: 003';
              POD_Edit.Text := 'Forest';
            end;
        end; end; {Case 3}
    3: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color4;
              if foobar then Color4 := ColorChanging;
              PO_TypeEdit.Text := 'Color4';
              POD_Edit.Text := 'Agriculture';
            end;
          1: begin
              ChangingColor := LLA;
              if foobar then LLA := ColorChanging;
              PO_TypeEdit.Text := 'LLA: 90';
              POD_Edit.Text := 'Dead Crops';
            end;
          2: begin
              ChangingColor := LMA;
              if foobar then LMA := ColorChanging;
              PO_TypeEdit.Text := 'LMA: 80';
              POD_Edit.Text := 'Pasture';
            end;
          3: begin
              ChangingColor := LDA;
              if foobar then LDA := ColorChanging;
              PO_TypeEdit.Text := 'LDA: 70';
              POD_Edit.Text := 'Crops';
            end;
          4: begin
              ChangingColor := MLA;
              if foobar then MLA := ColorChanging;
              PO_TypeEdit.Text := 'MLA: 60';
              POD_Edit.Text := 'IR Healthy Crops';
            end;
          5: begin
              ChangingColor := MMA;
              if foobar then MMA := ColorChanging;
              PO_TypeEdit.Text := 'MMA: 50';
              POD_Edit.Text := 'Irrigated Crops';
            end;
          6: begin
              ChangingColor := MDA;
              if foobar then MDA := ColorChanging;
              PO_TypeEdit.Text := 'MDA: 40';
              POD_Edit.Text := 'Nurseries: Mixed Ag';
            end;
          7: begin
              ChangingColor := DLA;
              if foobar then DLA := ColorChanging;
              PO_TypeEdit.Text := 'DLA: 30';
              POD_Edit.Text := 'Vineyards';
            end;
          8: begin
              ChangingColor := DMA;
              if foobar then DMA := ColorChanging;
              PO_TypeEdit.Text := 'DMA: 20';
              POD_Edit.Text := 'Confined Feeding Operations';
            end;
          9: begin
              ChangingColor := DDA;
              if foobar then DDA := ColorChanging;
              PO_TypeEdit.Text := 'DDA: 10';
              POD_Edit.Text := 'Orchards and Groves';
            end;
          10: begin
              ChangingColor := ULA;
              if foobar then ULA := ColorChanging;
              PO_TypeEdit.Text := 'ULA: 009';
              POD_Edit.Text := 'Agricultural';
            end;
          11: begin
              ChangingColor := UMA;
              if foobar then UMA := ColorChanging;
              PO_TypeEdit.Text := 'UMA: 008';
              POD_Edit.Text := 'Agricultural';
            end;
          12: begin
              ChangingColor := UDA;
              if foobar then UDA := ColorChanging;
              PO_TypeEdit.Text := 'UDA: 007';
              POD_Edit.Text := 'Agricultural';
            end;
          13: begin
              ChangingColor := VLA;
              if foobar then VLA := ColorChanging;
              PO_TypeEdit.Text := 'VLA: 006';
              POD_Edit.Text := 'Agricultural';
            end;
          14: begin
              ChangingColor := VMA;
              if foobar then VMA := ColorChanging;
              PO_TypeEdit.Text := 'VMA: 005';
              POD_Edit.Text := 'Agricultural';
            end;
          15: begin
              ChangingColor := VDA;
              if foobar then VDA := ColorChanging;
              PO_TypeEdit.Text := 'VDA: 004';
              POD_Edit.Text := 'Agricultural';
            end;
          16: begin
              ChangingColor := UVA;
              if foobar then UVA := ColorChanging;
              PO_TypeEdit.Text := 'UVA: 003';
              POD_Edit.Text := 'Agricultural';
            end;
        end; end; {Case 4}
    4: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color5;
              if foobar then Color5 := ColorChanging;
              PO_TypeEdit.Text := 'Color5';
              POD_Edit.Text := 'Rangeland';
            end;
          1: begin
              ChangingColor := LLR;
              if foobar then LLR := ColorChanging;
              PO_TypeEdit.Text := 'LLR: 90';
              POD_Edit.Text := 'Prairie: Dead';
            end;
          2: begin
              ChangingColor := LMR;
              if foobar then LMR := ColorChanging;
              PO_TypeEdit.Text := 'LMR: 80';
              POD_Edit.Text := 'Herb: Dead';
            end;
          3: begin
              ChangingColor := LDR;
              if foobar then LDR := ColorChanging;
              PO_TypeEdit.Text := 'LDR: 70';
              POD_Edit.Text := 'Shrub: Dead';
            end;
          4: begin
              ChangingColor := MLR;
              if foobar then MLR := ColorChanging;
              PO_TypeEdit.Text := 'MLR: 60';
              POD_Edit.Text := 'Prairie: OK';
            end;
          5: begin
              ChangingColor := MMR;
              if foobar then MMR := ColorChanging;
              PO_TypeEdit.Text := 'MMR: 50';
              POD_Edit.Text := 'Herb: OK';
            end;
          6: begin
              ChangingColor := MDR;
              if foobar then MDR := ColorChanging;
              PO_TypeEdit.Text := 'MDR: 40';
              POD_Edit.Text := 'Shrub: OK';
            end;
          7: begin
              ChangingColor := DLR;
              if foobar then DLR := ColorChanging;
              PO_TypeEdit.Text := 'DLR: 30';
              POD_Edit.Text := 'Prairie: Healthy';
            end;
          8: begin
              ChangingColor := DMR;
              if foobar then DMR := ColorChanging;
              PO_TypeEdit.Text := 'DMR: 20';
              POD_Edit.Text := 'Herbaceous Healthy';
            end;
          9: begin
              ChangingColor := DDR;
              if foobar then DDR := ColorChanging;
              PO_TypeEdit.Text := 'DDR: 10';
              POD_Edit.Text := 'Shrub and brush: Healthy';
            end;
          10: begin
              ChangingColor := ULR;
              if foobar then ULR := ColorChanging;
              PO_TypeEdit.Text := 'ULR 009';
              POD_Edit.Text := 'Rangeland';
            end;
          11: begin
              ChangingColor := UMR;
              if foobar then UMR := ColorChanging;
              PO_TypeEdit.Text := 'UMR: 008';
              POD_Edit.Text := 'Rangeland';
            end;
          12: begin
              ChangingColor := UDR;
              if foobar then UDR := ColorChanging;
              PO_TypeEdit.Text := 'UDR: 007';
              POD_Edit.Text := 'Rangeland';
            end;
          13: begin
              ChangingColor := VLR;
              if foobar then VLR := ColorChanging;
              PO_TypeEdit.Text := 'VLR: 006';
              POD_Edit.Text := 'Rangeland';
            end;
          14: begin
              ChangingColor := VMR;
              if foobar then VMR := ColorChanging;
              PO_TypeEdit.Text := 'VMR: 005';
              POD_Edit.Text := 'Rangeland';
            end;
          15: begin
              ChangingColor := VDR;
              if foobar then VDR := ColorChanging;
              PO_TypeEdit.Text := 'VDR 004';
              POD_Edit.Text := 'Rangeland';
            end;
          16: begin
              ChangingColor := UVR;
              if foobar then UVR := ColorChanging;
              PO_TypeEdit.Text := 'UVR: 003';
              POD_Edit.Text := 'Rangeland';
            end;
        end; end; {Case 5}
    5: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color6;
              if foobar then Color6 := ColorChanging;
              PO_TypeEdit.Text := 'Color6';
              POD_Edit.Text := 'Tundra';
            end;
          1: begin
              ChangingColor := LLT;
              if foobar then LLT := ColorChanging;
              PO_TypeEdit.Text := 'LLT: 90';
              POD_Edit.Text := 'Moss: Dead';
            end;
          2: begin
              ChangingColor := LMT;
              if foobar then LMT := ColorChanging;
              PO_TypeEdit.Text := 'LMT 80';
              POD_Edit.Text := 'Herb: Dead';
            end;
          3: begin
              ChangingColor := LDT;
              if foobar then LDT := ColorChanging;
              PO_TypeEdit.Text := 'LDT: 70';
              POD_Edit.Text := 'Shrub: Dead';
            end;
          4: begin
              ChangingColor := MLT;
              if foobar then MLT := ColorChanging;
              PO_TypeEdit.Text := 'MLT 60';
              POD_Edit.Text := 'Moss: OK';
            end;
          5: begin
              ChangingColor := MMT;
              if foobar then MMT := ColorChanging;
              PO_TypeEdit.Text := 'MMT: 50';
              POD_Edit.Text := 'Herb: OK';
            end;
          6: begin
              ChangingColor := MDT;
              if foobar then MDT := ColorChanging;
              PO_TypeEdit.Text := 'MDT: 40';
              POD_Edit.Text := 'Shrub: OK';
            end;
          7: begin
              ChangingColor := DLT;
              if foobar then DLT := ColorChanging;
              PO_TypeEdit.Text := 'DLT: 30';
              POD_Edit.Text := 'Moss: Healthy';
            end;
          8: begin
              ChangingColor := DMT;
              if foobar then DMT := ColorChanging;
              PO_TypeEdit.Text := 'DMT: 20';
              POD_Edit.Text := 'Herb: Healthy';
            end;
          9: begin
              ChangingColor := DDT;
              if foobar then DDT := ColorChanging;
              PO_TypeEdit.Text := 'DDT: 10';
              POD_Edit.Text := 'Shrub and Brush: Healthy';
            end;
          10: begin
              ChangingColor := ULT;
              if foobar then ULT := ColorChanging;
              PO_TypeEdit.Text := 'ULT: 009';
              POD_Edit.Text := 'Tundra';
            end;
          11: begin
              ChangingColor := UMT;
              if foobar then UMT := ColorChanging;
              PO_TypeEdit.Text := 'UMT: 008';
              POD_Edit.Text := 'Tundra';
            end;
          12: begin
              ChangingColor := UDT;
              if foobar then UDT := ColorChanging;
              PO_TypeEdit.Text := 'UDT: 007';
              POD_Edit.Text := 'Tundra';
            end;
          13: begin
              ChangingColor := VLT;
              if foobar then VLT := ColorChanging;
              PO_TypeEdit.Text := 'VLT: 006';
              POD_Edit.Text := 'Tundra';
            end;
          14: begin
              ChangingColor := VMT;
              if foobar then VMT := ColorChanging;
              PO_TypeEdit.Text := 'VMT: 005';
              POD_Edit.Text := 'Tundra';
            end;
          15: begin
              ChangingColor := VDT;
              if foobar then VDT := ColorChanging;
              PO_TypeEdit.Text := 'VDT: 004';
              POD_Edit.Text := 'Tundra';
            end;
          16: begin
              ChangingColor := UVT;
              if foobar then UVT := ColorChanging;
              PO_TypeEdit.Text := 'UVT: 003';
              POD_Edit.Text := 'Tundra';
            end;
        end; end; {Case 6}
    6: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color7;
              if foobar then Color7 := ColorChanging;
              PO_TypeEdit.Text := 'Color7';
              POD_Edit.Text := 'Barren Land';
            end;
          1: begin
              ChangingColor := LLB;
              if foobar then LLB := ColorChanging;
              PO_TypeEdit.Text := 'LLB: 90';
              POD_Edit.Text := 'Dry salt flats';
            end;
          2: begin
              ChangingColor := LMB;
              if foobar then LMB := ColorChanging;
              PO_TypeEdit.Text := 'LMB: 80';
              POD_Edit.Text := 'Sand: not beaches';
            end;
          3: begin
              ChangingColor := LDB;
              if foobar then LDB := ColorChanging;
              PO_TypeEdit.Text := 'LDB: 70';
              POD_Edit.Text := 'Beaches';
            end;
          4: begin
              ChangingColor := MLB;
              if foobar then MLB := ColorChanging;
              PO_TypeEdit.Text := 'MLB: 60';
              POD_Edit.Text := 'Bare Exposed Rock';
            end;
          5: begin
              ChangingColor := MMB;
              if foobar then MMB := ColorChanging;
              PO_TypeEdit.Text := 'MMB: 50';
              POD_Edit.Text := 'Transitional areas';
            end;
          6: begin
              ChangingColor := MDB;
              if foobar then MDB := ColorChanging;
              PO_TypeEdit.Text := 'MDB: 40';
              POD_Edit.Text := 'EPA NBC Zoned';
            end;
          7: begin
              ChangingColor := DLB;
              if foobar then DLB := ColorChanging;
              PO_TypeEdit.Text := 'DLB: 30';
              POD_Edit.Text := 'Gravel pits';
            end;
          8: begin
              ChangingColor := DMB;
              if foobar then DMB := ColorChanging;
              PO_TypeEdit.Text := 'DMB: 20';
              POD_Edit.Text := 'Quarries';
            end;
          9: begin
              ChangingColor := DDB;
              if foobar then DDB := ColorChanging;
              PO_TypeEdit.Text := 'DDB: 10';
              POD_Edit.Text := 'Strip Mines';
            end;
          10: begin
              ChangingColor := ULB;
              if foobar then ULB := ColorChanging;
              PO_TypeEdit.Text := 'ULB: 009';
              POD_Edit.Text := 'Barren Land';
            end;
          11: begin
              ChangingColor := UMB;
              if foobar then UMB := ColorChanging;
              PO_TypeEdit.Text := 'UMB: 008';
              POD_Edit.Text := 'Barren Land';
            end;
          12: begin
              ChangingColor := UDB;
              if foobar then UDB := ColorChanging;
              PO_TypeEdit.Text := 'UDB: 007';
              POD_Edit.Text := 'Barren Land';
            end;
          13: begin
              ChangingColor := VLB;
              if foobar then VLB := ColorChanging;
              PO_TypeEdit.Text := 'VLB: 006';
              POD_Edit.Text := 'Barren Land';
            end;
          14: begin
              ChangingColor := VMB;
              if foobar then VMB := ColorChanging;
              PO_TypeEdit.Text := 'VMB: 005';
              POD_Edit.Text := 'Barren Land';
            end;
          15: begin
              ChangingColor := VDB;
              if foobar then VDB := ColorChanging;
              PO_TypeEdit.Text := 'VDB: 004';
              POD_Edit.Text := 'Barren Land';
            end;
          16: begin
              ChangingColor := UVB;
              if foobar then UVB := ColorChanging;
              PO_TypeEdit.Text := 'UVB: 003';
              POD_Edit.Text := 'Barren Land';
            end;
        end; end; {Case 7}
    7: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color8;
              if foobar then Color8 := ColorChanging;
              PO_TypeEdit.Text := 'Color8';
              POD_Edit.Text := 'Urban';
            end;
          1: begin
              ChangingColor := LLU;
              if foobar then LLU := ColorChanging;
              PO_TypeEdit.Text := 'LLU: 90';
              POD_Edit.Text := 'Industrial Extraction';
            end;
          2: begin
              ChangingColor := LMU;
              if foobar then LMU := ColorChanging;
              PO_TypeEdit.Text := 'LMU: 80';
              POD_Edit.Text := 'Industrial Production';
            end;
          3: begin
              ChangingColor := LDU;
              if foobar then LDU := ColorChanging;
              PO_TypeEdit.Text := 'LDU: 70';
              POD_Edit.Text := 'Industrial and Commercial complexes';
            end;
          4: begin
              ChangingColor := MLU;
              if foobar then MLU := ColorChanging;
              PO_TypeEdit.Text := 'MLU: 60';
              POD_Edit.Text := 'Commercial and Services';
            end;
          5: begin
              ChangingColor := MMU;
              if foobar then MMU := ColorChanging;
              PO_TypeEdit.Text := 'MMU: 50';
              POD_Edit.Text := 'Major Roads: Transportation';
            end;
          6: begin
              ChangingColor := MDU;
              if foobar then MDU := ColorChanging;
              PO_TypeEdit.Text := 'MDU: 40';
              POD_Edit.Text := 'Minor Roads: Transportation';
            end;
          7: begin
              ChangingColor := DLU;
              if foobar then DLU := ColorChanging;
              PO_TypeEdit.Text := 'DLU: 30';
              POD_Edit.Text := 'Utilities';
            end;
          8: begin
              ChangingColor := DMU;
              if foobar then DMU := ColorChanging;
              PO_TypeEdit.Text := 'DMU: 20';
              POD_Edit.Text := 'Communications';
            end;
          9: begin
              ChangingColor := DDU;
              if foobar then DDU := ColorChanging;
              PO_TypeEdit.Text := 'DDU: 10';
              POD_Edit.Text := 'Residential';
            end;
          10: begin
              ChangingColor := ULU;
              if foobar then ULU := ColorChanging;
              PO_TypeEdit.Text := 'ULU: 009';
              POD_Edit.Text := 'Urban';
            end;
          11: begin
              ChangingColor := UMU;
              if foobar then UMU := ColorChanging;
              PO_TypeEdit.Text := 'UMU: 008';
              POD_Edit.Text := 'Urban';
            end;
          12: begin
              ChangingColor := UDU;
              if foobar then UDU := ColorChanging;
              PO_TypeEdit.Text := 'UDU: 007';
              POD_Edit.Text := 'Urban';
            end;
          13: begin
              ChangingColor := VLU;
              if foobar then VLU := ColorChanging;
              PO_TypeEdit.Text := 'VLU: 006';
              POD_Edit.Text := 'Urban';
            end;
          14: begin
              ChangingColor := VMU;
              if foobar then VMU := ColorChanging;
              PO_TypeEdit.Text := 'VMU: 005';
              POD_Edit.Text := 'Urban';
            end;
          15: begin
              ChangingColor := VDU;
              if foobar then VDU := ColorChanging;
              PO_TypeEdit.Text := 'VDU: 004';
              POD_Edit.Text := 'Urban';
            end;
          16: begin
              ChangingColor := UVU;
              if foobar then UVU := ColorChanging;
              PO_TypeEdit.Text := 'UVU: 003';
              POD_Edit.Text := 'Urban';
            end;
        end; end; {Case 8}
    8: begin
        case ChangeRow of
          0: begin
              ChangingColor := Color9;
              if foobar then Color9 := ColorChanging;
              PO_TypeEdit.Text := 'Color9';
              POD_Edit.Text := 'Snow or Ice';
            end;
          1: begin
              ChangingColor := LLS;
              if foobar then LLS := ColorChanging;
              PO_TypeEdit.Text := 'LLS: 90';
              POD_Edit.Text := 'New Snow';
            end;
          2: begin
              ChangingColor := LMS;
              if foobar then LMS := ColorChanging;
              PO_TypeEdit.Text := 'LMS: 80';
              POD_Edit.Text := 'White Snow';
            end;
          3: begin
              ChangingColor := LDS;
              if foobar then LDS := ColorChanging;
              PO_TypeEdit.Text := 'LDS: 70';
              POD_Edit.Text := 'Snow Fields';
            end;
          4: begin
              ChangingColor := MLS;
              if foobar then MLS := ColorChanging;
              PO_TypeEdit.Text := 'MLS: 60';
              POD_Edit.Text := 'Broken Snow';
            end;
          5: begin
              ChangingColor := MMS;
              if foobar then MMS := ColorChanging;
              PO_TypeEdit.Text := 'MMS: 50';
              POD_Edit.Text := 'Ice Fields';
            end;
          6: begin
              ChangingColor := MDS;
              if foobar then MDS := ColorChanging;
              PO_TypeEdit.Text := 'MDS: 40';
              POD_Edit.Text := 'Moving Ice-Flows';
            end;
          7: begin
              ChangingColor := DLS;
              if foobar then DLS := ColorChanging;
              PO_TypeEdit.Text := 'DLS: 30';
              POD_Edit.Text := 'Mountain Ice';
            end;
          8: begin
              ChangingColor := DMS;
              if foobar then DMS := ColorChanging;
              PO_TypeEdit.Text := 'DMS: 20';
              POD_Edit.Text := 'Icebergs';
            end;
          9: begin
              ChangingColor := DDS;
              if foobar then DDS := ColorChanging;
              PO_TypeEdit.Text := 'DDS: 10';
              POD_Edit.Text := 'Glaciers';
            end;
          10: begin
              ChangingColor := ULS;
              if foobar then ULS := ColorChanging;
              PO_TypeEdit.Text := 'ULS: 009';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          11: begin
              ChangingColor := UMS;
              if foobar then UMS := ColorChanging;
              PO_TypeEdit.Text := 'UMS: 008';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          12: begin
              ChangingColor := UDS;
              if foobar then UDS := ColorChanging;
              PO_TypeEdit.Text := 'UDS: 007';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          13: begin
              ChangingColor := VLS;
              if foobar then VLS := ColorChanging;
              PO_TypeEdit.Text := 'VLS: 006';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          14: begin
              ChangingColor := VMS;
              if foobar then VMS := ColorChanging;
              PO_TypeEdit.Text := 'VMS 005';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          15: begin
              ChangingColor := VDS;
              if foobar then VDS := ColorChanging;
              PO_TypeEdit.Text := 'VDS: 004';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
          16: begin
              ChangingColor := UVS;
              if foobar then UVS := ColorChanging;
              PO_TypeEdit.Text := 'UVS: 003';
              POD_Edit.Text := 'Snow: Glaciers';
            end;
        end; end; {Case 9}
  end; {Case} end; {PROCEDURE}
(********************************************************************)
(********************************************************************)

procedure TOptionsForm.VoicesCBClick(Sender: TObject);
begin
  VoicesOn := VoicesCB.Checked;
end;

procedure TOptionsForm.BellsCBClick(Sender: TObject);
begin
  BellsOn := BellsCB.Checked;
end;

procedure TOptionsForm.WhistlesCBClick(Sender: TObject);
begin
  WhistlesOn := WhistlesCB.Checked;
end;

procedure TOptionsForm.ErrorNotUsedCBClick(Sender: TObject);
begin
  ErrorBeepOn := ErrorNotUsedCB.Checked;
end;

procedure TOptionsForm.ErrorVoiceCBClick(Sender: TObject);
begin
  ErrorVoiceOn := ErrorVoiceCB.Checked;
end;

procedure TOptionsForm.DoneNotificationCBClick(Sender: TObject);
begin
  DoneBeepOn := DoneNotificationCB.Checked;
end;

procedure TOptionsForm.SavePreviewCBClick(Sender: TObject);
begin
  SaveWithPreview := SavePreviewCB.Checked;
end;

procedure TOptionsForm.OpenPreviewCBClick(Sender: TObject);
begin
  OpenWithPreview := OpenPreviewCB.Checked;
end;

procedure TOptionsForm.PO_ToggleRGClick(Sender: TObject);
begin
  Toggle_D_B := False;
  Toggle_D_G := False;
  Toggle_D_R := False;
  Toggle_D_RGB := False;
  case PO_ToggleRG.ItemIndex of
    0: Toggle_D_B := True;
    1: Toggle_D_G := True;
    2: Toggle_D_R := True;
    3: Toggle_D_RGB := True;
  end; {case}
end;

procedure TOptionsForm.AbsoluteValuesCBClick(Sender: TObject);
begin
  V_Absolute := AbsoluteValuesCB.Checked;
end;

procedure TOptionsForm.SetAbsoluteValueCBClick(Sender: TObject);
begin
  R_AutoTT := SetAbsoluteValueCB.Checked;
end;

procedure TOptionsForm.SetAutorangeThresholdCBClick(Sender: TObject);
begin
  S_Threshold := SetAutorangeThresholdCB.Checked;
end;

procedure TOptionsForm.TogglesRGClick(Sender: TObject);
begin
  ClipR := False;
  Do_Ex_com := False;
  BelowZero := False;
  AutoRange := False;
  case TogglesRG.ItemIndex of
    0: ClipR := True;
    1: Do_Ex_com := True;
    2: BelowZero := True;
    3: AutoRange := True;
  end; end;

procedure TOptionsForm.CurrentColorPanelClick(Sender: TObject);
begin
  if ColorDialog1.Execute then begin
    CurrentColorPanel.Color := ColorDialog1.Color;
    CurrentColor := CurrentColorPanel.Color;
  end;
end;

procedure TOptionsForm.RealATMinEditChange(Sender: TObject);
var eCode: Integer;
begin
  val(RealATMinEdit.Text, dAT_Min, eCode); Codefx(RealATMinEdit.Text,
    eCode);
end;

procedure TOptionsForm.RealATMaxEditChange(Sender: TObject);
var eCode: Integer;
begin
  val(RealATMaxEdit.Text, dAT_Max, eCode); Codefx(RealATMaxEdit.Text,
    eCode);
end;

procedure TOptionsForm.IntATMinEditChange(Sender: TObject);
var eCode: Integer;
begin
  val(IntATMinEdit.Text, bST_Min, eCode); Codefx(IntATMinEdit.Text,
    eCode);
end;

procedure TOptionsForm.IntATMaxEditChange(Sender: TObject);
var eCode: Integer;
begin
  val(IntATMaxEdit.Text, bST_Max, eCode); Codefx(IntATMaxEdit.Text,
    eCode);
end;








end.
