{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit gVCScreen;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, ComCtrls;

type
  TViewCursorScreen = class(TForm)
    CursorPixelValues: TStringGrid;
    Panel1: TPanel;
    VCSClose: TBitBtn;
    VCSHelp: TBitBtn;
    VCSPrintBtn: TBitBtn;
    VCSSaveBtn: TBitBtn;
    SaveDialog1: TSaveDialog;
    VCMemo: TRichEdit;
    procedure VCSCloseClick(Sender: TObject);
    procedure VCSHelpClick(Sender: TObject);
    procedure VCSPrintBtnClick(Sender: TObject);
    procedure VCSSave;
    procedure VCSSaveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ViewCursorScreen: TViewCursorScreen;

implementation

{$R *.DFM}
uses gGlobal, gGrip;

procedure TViewCursorScreen.FormCreate(Sender: TObject);
begin
  left := ViewCursorScreenX;
  top := ViewCursorScreenY;
end;

procedure TViewCursorScreen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ViewCursorScreenX := ViewCursorScreen.left;
  ViewCursorScreenY := ViewCursorScreen.top;
  GRIPForm.IV_PixelValuesUnClick;
  DoSaver;
end;

procedure TViewCursorScreen.VCSCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TViewCursorScreen.VCSHelpClick(Sender: TObject);
begin
  Application.HelpContext(5500);
end;

procedure TViewCursorScreen.VCSPrintBtnClick(Sender: TObject);
begin
{Print the 25 x 25 pixel values}
  VCMemo.Clear;
  VCSSave;
  VCMemo.Print('Pixels of ' + GRIPFileName);
end;

procedure TViewCursorScreen.VCSSave;
var
  Counter, Rower, IL, IW: Integer;
  AllRGB: string;
begin
  SaveDialog1.filter := 'Cursor txt files|*.txt';
  {set SaveDialog Default extension}
  SaveDialog1.DefaultExt := 'txt';
  if SaveDialog1.Execute then {Save it}
  begin
{Save the 25 x 25 pixel values }
    Counter := -1; {Reversed : Bitmap is stored upside down}
    for IL := 0 to 24 do begin
      inc(Counter);
      Rower := -1;
      for IW := 0 to 24 do begin
        inc(Rower);
        AllRGB := CursorPixelValues.Cells[Counter, Rower];
        VCMemo.Lines.Append(' Row ' + inttostr(IL)
          + ' Col ' + inttostr(IW)
          + ' : ' + AllRGB);
      end; end;
    VCMemo.Lines.Savetofile(SaveDialog1.Filename);
  end;
end;


procedure TViewCursorScreen.VCSSaveBtnClick(Sender: TObject);
begin
  VCMemo.Clear;
  VCSSave;
end;


procedure TViewCursorScreen.FormShow(Sender: TObject);
var
  RedColor, BlueColor, GreenColor: Byte;
  Counter, Rower: Integer;
{,  ILStart, ILEnd, IWStart, IWEnd: Integer;}
  IL, IW: DWord;
  AllRGB, ValueR, ValueG, ValueB, ValueB12: string;
begin {Get current Window DC}
  MakeImage;
{    ILStart :=ViewY1;
    IWStart :=ViewX1;
    ILEnd :=ViewY2;
    IWEnd :=ViewX2;}
  Counter := -1;
    {Reversed : Bitmap is stored upside down}
{      FOR IL :=ViewY2  downto ViewY1 DO Begin }
  for IL := ImageHeight - ViewY1 downto ImageHeight - ViewY2 do begin
    inc(Counter); Rower := -1;
    for IW := ViewX1 to ViewX2 do begin
      inc(Rower);
      WherePixel := (((IW) * 3) + (IL * BytesPerLine));
      lpPixelB := @PHugeByteArray(Undo)^[WherePixel];
      lpPixelG := @PHugeByteArray(Undo)^[WherePixel + 1];
      lpPixelR := @PHugeByteArray(Undo)^[WherePixel + 2];
      BlueColor := lpPixelB^; GreenColor := lpPixelG^; RedColor :=
      lpPixelR^;
      Str(RedColor, ValueR); Str(GreenColor, ValueG); Str(BlueColor,
        ValueB);
      AllRGB := (ValueR + ',' + ValueG + ',' + ValueB);
      CursorPixelValues.Cells[Counter, Rower] := AllRGB;
    end; end;
  FreeImage;
  Str(ViewX1, ValueR); Str(ViewX2, ValueG);
  Str(ViewY1, ValueB); Str(ViewY2, ValueB12);
  AllRGB := ('X: ' + ValueR + '.. ' + ValueG + ' Y: ' + ValueB + '.. '
    + ValueB12 + '   ');
  Panel1.Caption := AllRGB;
end;



end.
